#!/usr/bin/python -u
import sys
import os
from malib import *

## Note: this schedule is two EWFs so the latency for one EWF is half the total latency

outname = sys.argv[1]

if not outname == "term":
        print "Output to",outname
        sys.stdout = open(outname,"w")

alus = int(sys.argv[2])
mults = int(sys.argv[3])
registers = int(sys.argv[4])

print os.times()

class Top(Model):

	def __init__(self,parent):

		Model.__init__(self,parent)
		self.submodels = []

		self.a0 = COp1(self,2)
		self.a1 = COp1(self,0)
		self.a2 = COp1(self,2)
		self.a3 = COp1(self,0)
		self.a4 = COp1(self,2)
		self.ma5 = COp2p(self,0)
		self.a6 = COp1(self,0)
		self.a7 = COp1(self,0)
		self.a8 = COp1(self,1)
		self.a9 = COp1(self,1)
		self.a10 = COp1(self,0)
		self.ma11 = COp2p(self,0)
		self.a12 = COp1(self,0)
		self.a13 = COp1(self,2)
		self.a14 = COp1(self,0)
		self.ma15 = COp2p(self,0)
		self.a16 = COp1(self,0)
		self.a17 = COp1(self,0)
		self.ma18 = COp2p(self,0)
		self.a19 = COp1(self,0)
		self.ma20 = COp2p(self,0)
		self.a21 = COp1(self,2)
		self.ma22 = COp2p(self,0)
		self.a23 = COp1(self,1)
		self.a24 = COp1(self,0)
		self.a25 = COp1(self,1)
		self.a26 = COp1(self,2)
		self.ma27 = COp2p(self,0)
		self.a28 = COp1(self,1)
		self.a29 = COp1(self,0)
		self.a30 = COp1(self,2)
		self.ma31 = COp2p(self,0)
		self.a32 = COp1(self,1)
		self.a33 = COp1(self,0)
		self.a34 = COp1(self,0)
		self.a35 = COp1(self,0)
		self.a36 = COp1(self,0)
		self.a37 = COp1(self,0)
		self.a38 = COp1(self,1)
		self.ma39 = COp2p(self,0)
		self.a40 = COp1(self,0)
		self.a41 = COp1(self,0)
		self.a42 = COp1(self,2)
		self.a43 = COp1(self,1)
		self.a44 = COp1(self,0)
		self.ma45 = COp2p(self,0)
		self.a46 = COp1(self,0)
		self.a47 = COp1(self,1)
		self.a48 = COp1(self,0)
		self.ma49 = COp2p(self,0)
		self.a50 = COp1(self,0)
		self.a51 = COp1(self,2)
		self.ma52 = COp2p(self,0)
		self.a53 = COp1(self,0)
		self.ma54 = COp2p(self,0)
		self.a55 = COp1(self,2)
		self.ma56 = COp2p(self,0)
		self.a57 = COp1(self,2)
		self.a58 = COp1(self,0)
		self.a59 = COp1(self,2)
		self.a60 = COp1(self,1)
		self.ma61 = COp2p(self,0)
		self.a62 = COp1(self,2)
		self.a63 = COp1(self,2)
		self.a64 = COp1(self,1)
		self.ma65 = COp2p(self,0)
		self.a66 = COp1(self,2)
		self.a67 = COp1(self,2)

		self.outtags = [self.a42, self.a51, self.ma54, self.a55, self.a62, self.a63, self.a66, self.a67, ]
                self.AddNames()

	def BuildRelation(self):
		Model.BuildCompositeTR(self)
		set = []

		Enable(set,self.ma22.known[0],self.a23.required[0])
		Enable(set,self.a23.known[0],self.a24.required[1])
		Enable(set,self.a41.known[0],self.a42.required[0])
		Enable(set,self.a10.known[0],self.ma11.required[0])
		Enable(set,self.ma31.known[0],self.a32.required[0])
		Enable(set,self.ma11.known[0],self.a12.required[0])
		Enable(set,self.ma39.known[0],self.a40.required[0])
		Enable(set,self.ma49.known[0],self.a50.required[0])
		Enable(set,self.a7.known[0],self.a8.required[0])
		Enable(set,self.a28.known[0],self.a29.required[0])
		Enable(set,self.a57.known[0],self.a58.required[1])
		Enable(set,self.ma56.known[0],self.a57.required[0])
		Enable(set,self.ma54.known[0],self.a55.required[0])
		Enable(set,self.a60.known[0],self.ma61.required[0])
		Enable(set,self.ma61.known[0],self.a62.required[0])
		Enable(set,self.ma52.known[0],self.a53.required[0])
		Enable(set,self.a62.known[0],self.a63.required[0])
		Enable(set,self.a50.known[0],self.a51.required[1])
		Enable(set,self.a47.known[0],self.a48.required[0])
		Enable(set,self.ma15.known[0],self.a16.required[0])
		Enable(set,self.a64.known[0],self.ma65.required[0])
		Enable(set,self.ma65.known[0],self.a66.required[0])
		Enable(set,self.a2.known[0],self.a3.required[0])
		Enable(set,self.a47.known[0],self.a46.required[1])
		Enable(set,self.a66.known[0],self.a67.required[1])
		Enable(set,self.a16.known[0],self.a17.required[1])
		Enable(set,self.ma45.known[0],self.a46.required[0])
		Enable(set,self.ma18.known[0],self.a19.required[0])
		Enable(set,self.a44.known[0],self.ma45.required[0])
		Enable(set,self.ma20.known[0],self.a21.required[0])
		Enable(set,self.ma5.known[0],self.a6.required[0])
		Enable(set,self.a40.known[0],self.a41.required[1])
		Enable(set,self.a13.known[0],self.a12.required[1])
		Enable(set,self.a36.known[0],self.a37.required[0])
		Enable(set,self.a6.known[0],self.a7.required[1])
		Enable(set,self.a0.known[0],self.a1.required[0])
		Enable(set,self.a34.known[0],self.a35.required[0])
		Enable(set,self.a32.known[0],self.a33.required[1])
		Enable(set,self.a30.known[0],self.ma31.required[0])
		Enable(set,self.a13.known[0],self.a14.required[0])
		Enable(set,self.a26.known[0],self.ma27.required[0])
		Enable(set,self.ma27.known[0],self.a28.required[0])
		Enable(set,self.a53.known[0],self.a51.required[0])
		Enable(set,self.a36.known[0],self.a38.required[0])
		Enable(set,self.a19.known[0],self.a17.required[0])
		Enable(set,self.a57.known[0],self.a55.required[1])
		Enable(set,self.a58.known[0],self.a60.required[0])
		Enable(set,self.a34.known[0],self.a36.required[0])
		Enable(set,self.a2.known[0],self.a4.required[0])
		Enable(set,self.a12.known[0],self.a14.required[1])
		Enable(set,self.a23.known[0],self.a21.required[1])
		Enable(set,self.a24.known[0],self.a26.required[0])
		Enable(set,self.a23.known[0],self.a25.required[0])
		Enable(set,self.a57.known[0],self.a59.required[0])
		Enable(set,self.a0.known[0],self.a2.required[0])
		Enable(set,self.a46.known[0],self.a48.required[1])
		Enable(set,self.a13.known[0],self.a10.required[1])
		Enable(set,self.a26.known[0],self.a29.required[1])
		Enable(set,self.a10.known[0],self.a7.required[0])
		Enable(set,self.a64.known[0],self.a67.required[0])
		Enable(set,self.a30.known[0],self.a33.required[0])
		Enable(set,self.a6.known[0],self.a9.required[1])
		Enable(set,self.a33.known[0],self.a36.required[1])
		Enable(set,self.a40.known[0],self.a37.required[1])
		Enable(set,self.a44.known[0],self.a41.required[0])
		Enable(set,self.a60.known[0],self.a63.required[1])
		Enable(set,self.a6.known[0],self.a3.required[1])
		Enable(set,self.a40.known[0],self.a43.required[1])
		Enable(set,self.a47.known[0],self.a44.required[1])
		Enable(set,self.a12.known[0],self.a8.required[1])
		Enable(set,self.a36.known[0],self.a40.required[1])
		Enable(set,self.a2.known[0],self.a6.required[1])
		Enable(set,self.a46.known[0],self.a42.required[1])
		Enable(set,self.a25.known[0],self.ma20.required[0])
		Enable(set,self.a10.known[0],self.ma5.required[0])
		Enable(set,self.a44.known[0],self.ma39.required[0])
		Enable(set,self.a59.known[0],self.ma54.required[0])
		Enable(set,self.a4.known[0],self.a10.required[0])
		Enable(set,self.a38.known[0],self.a44.required[0])
		Enable(set,self.a50.known[0],self.a43.required[0])
		Enable(set,self.a16.known[0],self.a9.required[0])
		Enable(set,self.a14.known[0],self.ma22.required[0])
		Enable(set,self.a48.known[0],self.ma56.required[0])
		Enable(set,self.a3.known[0],self.ma15.required[0])
		Enable(set,self.a46.known[0],self.a58.required[0])
		Enable(set,self.a12.known[0],self.a24.required[0])
		Enable(set,self.a37.known[0],self.ma49.required[0])
		Enable(set,self.a50.known[0],self.a35.required[1])
		Enable(set,self.a16.known[0],self.a1.required[1])
		Enable(set,self.a0.known[0],self.a16.required[1])
		Enable(set,self.a34.known[0],self.a50.required[1])
		Enable(set,self.a35.known[0],self.ma52.required[0])
		Enable(set,self.a17.known[0],self.a34.required[0])
		Enable(set,self.a1.known[0],self.ma18.required[0])
		Enable(set,self.a29.known[0],self.a47.required[0])
		Enable(set,self.a9.known[0],self.a30.required[0])


		vec = List2Vec(set)
		self.TR[0].rel = self.TR[0].rel & vec.And()

		set = []

		Enable(set,self.a43.known[0],self.a64.required[0])
		Enable(set,self.a21.known[0],self.a47.required[1])
		Enable(set,self.a8.known[0],self.a38.required[1])
		IEnable(set,self.a55.known[0],self.a25.required[1])
		Enable(set,self.a32.known[0],self.a64.required[1])
		Enable(set,self.a28.known[0],self.a60.required[1])
		IEnable(set,self.a55.known[0],self.a23.required[1])
		Enable(set,self.a28.known[0],self.a62.required[1])
		IEnable(set,self.a62.known[0],self.a28.required[1])
		IEnable(set,self.a66.known[0],self.a32.required[1])
		Enable(set,self.a32.known[0],self.a66.required[1])
		IEnable(set,self.a66.known[0],self.a30.required[1])


		vec = List2Vec(set)
		self.TR[1].rel = self.TR[1].rel & vec.And()

		set = []

		Enable(set,self.a21.known[0],self.a57.required[1])
		IEnable(set,self.a62.known[0],self.a26.required[1])
		IEnable(set,self.a42.known[0],self.a4.required[1])
		Enable(set,self.a21.known[0],self.a59.required[1])
		IEnable(set,self.a55.known[0],self.a13.required[1])
		IEnable(set,self.a63.known[0],self.a13.required[0])
		IEnable(set,self.a51.known[0],self.a0.required[0])
		IEnable(set,self.a67.known[0],self.a2.required[1])


		vec = List2Vec(set)
		self.TR[2].rel = self.TR[2].rel & vec.And()

		set = []

		Capacity(set,self.ma22.known[0],self.a23.accepted[0])
		Capacity(set,self.a23.known[0],self.a24.accepted[1])
		Capacity(set,self.a41.known[0],self.a42.accepted[0])
		Capacity(set,self.a10.known[0],self.ma11.accepted[0])
		Capacity(set,self.ma31.known[0],self.a32.accepted[0])
		Capacity(set,self.ma11.known[0],self.a12.accepted[0])
		Capacity(set,self.ma39.known[0],self.a40.accepted[0])
		Capacity(set,self.ma49.known[0],self.a50.accepted[0])
		Capacity(set,self.a7.known[0],self.a8.accepted[0])
		Capacity(set,self.a28.known[0],self.a29.accepted[0])
		Capacity(set,self.a57.known[0],self.a58.accepted[1])
		Capacity(set,self.ma56.known[0],self.a57.accepted[0])
		Capacity(set,self.ma54.known[0],self.a55.accepted[0])
		Capacity(set,self.a60.known[0],self.ma61.accepted[0])
		Capacity(set,self.ma61.known[0],self.a62.accepted[0])
		Capacity(set,self.ma52.known[0],self.a53.accepted[0])
		Capacity(set,self.a62.known[0],self.a63.accepted[0])
		Capacity(set,self.a50.known[0],self.a51.accepted[1])
		Capacity(set,self.a47.known[0],self.a48.accepted[0])
		Capacity(set,self.ma15.known[0],self.a16.accepted[0])
		Capacity(set,self.a64.known[0],self.ma65.accepted[0])
		Capacity(set,self.ma65.known[0],self.a66.accepted[0])
		Capacity(set,self.a2.known[0],self.a3.accepted[0])
		Capacity(set,self.a47.known[0],self.a46.accepted[1])
		Capacity(set,self.a66.known[0],self.a67.accepted[1])
		Capacity(set,self.a16.known[0],self.a17.accepted[1])
		Capacity(set,self.ma45.known[0],self.a46.accepted[0])
		Capacity(set,self.ma18.known[0],self.a19.accepted[0])
		Capacity(set,self.a44.known[0],self.ma45.accepted[0])
		Capacity(set,self.ma20.known[0],self.a21.accepted[0])
		Capacity(set,self.ma5.known[0],self.a6.accepted[0])
		Capacity(set,self.a40.known[0],self.a41.accepted[1])
		Capacity(set,self.a13.known[0],self.a12.accepted[1])
		Capacity(set,self.a36.known[0],self.a37.accepted[0])
		Capacity(set,self.a6.known[0],self.a7.accepted[1])
		Capacity(set,self.a0.known[0],self.a1.accepted[0])
		Capacity(set,self.a34.known[0],self.a35.accepted[0])
		Capacity(set,self.a32.known[0],self.a33.accepted[1])
		Capacity(set,self.a30.known[0],self.ma31.accepted[0])
		Capacity(set,self.a13.known[0],self.a14.accepted[0])
		Capacity(set,self.a26.known[0],self.ma27.accepted[0])
		Capacity(set,self.ma27.known[0],self.a28.accepted[0])
		Capacity(set,self.a53.known[0],self.a51.accepted[0])
		Capacity(set,self.a36.known[0],self.a38.accepted[0])
		Capacity(set,self.a19.known[0],self.a17.accepted[0])
		Capacity(set,self.a57.known[0],self.a55.accepted[1])
		Capacity(set,self.a58.known[0],self.a60.accepted[0])
		Capacity(set,self.a34.known[0],self.a36.accepted[0])
		Capacity(set,self.a2.known[0],self.a4.accepted[0])
		Capacity(set,self.a12.known[0],self.a14.accepted[1])
		Capacity(set,self.a23.known[0],self.a21.accepted[1])
		Capacity(set,self.a24.known[0],self.a26.accepted[0])
		Capacity(set,self.a23.known[0],self.a25.accepted[0])
		Capacity(set,self.a57.known[0],self.a59.accepted[0])
		Capacity(set,self.a0.known[0],self.a2.accepted[0])
		Capacity(set,self.a46.known[0],self.a48.accepted[1])
		Capacity(set,self.a13.known[0],self.a10.accepted[1])
		Capacity(set,self.a26.known[0],self.a29.accepted[1])
		Capacity(set,self.a10.known[0],self.a7.accepted[0])
		Capacity(set,self.a64.known[0],self.a67.accepted[0])
		Capacity(set,self.a30.known[0],self.a33.accepted[0])
		Capacity(set,self.a6.known[0],self.a9.accepted[1])
		Capacity(set,self.a33.known[0],self.a36.accepted[1])
		Capacity(set,self.a40.known[0],self.a37.accepted[1])
		Capacity(set,self.a44.known[0],self.a41.accepted[0])
		Capacity(set,self.a60.known[0],self.a63.accepted[1])
		Capacity(set,self.a6.known[0],self.a3.accepted[1])
		Capacity(set,self.a40.known[0],self.a43.accepted[1])
		Capacity(set,self.a47.known[0],self.a44.accepted[1])
		Capacity(set,self.a12.known[0],self.a8.accepted[1])
		Capacity(set,self.a36.known[0],self.a40.accepted[1])
		Capacity(set,self.a2.known[0],self.a6.accepted[1])
		Capacity(set,self.a46.known[0],self.a42.accepted[1])
		Capacity(set,self.a25.known[0],self.ma20.accepted[0])
		Capacity(set,self.a10.known[0],self.ma5.accepted[0])
		Capacity(set,self.a44.known[0],self.ma39.accepted[0])
		Capacity(set,self.a59.known[0],self.ma54.accepted[0])
		Capacity(set,self.a4.known[0],self.a10.accepted[0])
		Capacity(set,self.a38.known[0],self.a44.accepted[0])
		Capacity(set,self.a50.known[0],self.a43.accepted[0])
		Capacity(set,self.a16.known[0],self.a9.accepted[0])
		Capacity(set,self.a14.known[0],self.ma22.accepted[0])
		Capacity(set,self.a48.known[0],self.ma56.accepted[0])
		Capacity(set,self.a3.known[0],self.ma15.accepted[0])
		Capacity(set,self.a46.known[0],self.a58.accepted[0])
		Capacity(set,self.a12.known[0],self.a24.accepted[0])
		Capacity(set,self.a37.known[0],self.ma49.accepted[0])
		Capacity(set,self.a50.known[0],self.a35.accepted[1])
		Capacity(set,self.a16.known[0],self.a1.accepted[1])
		Capacity(set,self.a0.known[0],self.a16.accepted[1])
		Capacity(set,self.a34.known[0],self.a50.accepted[1])
		Capacity(set,self.a35.known[0],self.ma52.accepted[0])
		Capacity(set,self.a17.known[0],self.a34.accepted[0])
		Capacity(set,self.a1.known[0],self.ma18.accepted[0])
		Capacity(set,self.a29.known[0],self.a47.accepted[0])
		Capacity(set,self.a9.known[0],self.a30.accepted[0])


		vec = List2Vec(set)
		self.TR[0].rel = self.TR[0].rel & vec.And()

		set = []

		Capacity(set,self.a43.known[0],self.a64.accepted[0])
		Capacity(set,self.a21.known[0],self.a47.accepted[1])
		Capacity(set,self.a8.known[0],self.a38.accepted[1])
		ICapacity(set,self.a55.known[0],self.a25.accepted[1])
		Capacity(set,self.a32.known[0],self.a64.accepted[1])
		Capacity(set,self.a28.known[0],self.a60.accepted[1])
		ICapacity(set,self.a55.known[0],self.a23.accepted[1])
		Capacity(set,self.a28.known[0],self.a62.accepted[1])
		ICapacity(set,self.a62.known[0],self.a28.accepted[1])
		ICapacity(set,self.a66.known[0],self.a32.accepted[1])
		Capacity(set,self.a32.known[0],self.a66.accepted[1])
		ICapacity(set,self.a66.known[0],self.a30.accepted[1])


		vec = List2Vec(set)
		self.TR[1].rel = self.TR[1].rel & vec.And()

		set = []

		Capacity(set,self.a21.known[0],self.a57.accepted[1])
		ICapacity(set,self.a62.known[0],self.a26.accepted[1])
		ICapacity(set,self.a42.known[0],self.a4.accepted[1])
		Capacity(set,self.a21.known[0],self.a59.accepted[1])
		ICapacity(set,self.a55.known[0],self.a13.accepted[1])
		ICapacity(set,self.a63.known[0],self.a13.accepted[0])
		ICapacity(set,self.a51.known[0],self.a0.accepted[0])
		ICapacity(set,self.a67.known[0],self.a2.accepted[1])


		vec = List2Vec(set)
		self.TR[2].rel = self.TR[2].rel & vec.And()


	def BuildGroups(self):

                alu_list = [self.a0.busy[0], self.a1.busy[0], self.a2.busy[0], self.a3.busy[0], self.a4.busy[0], self.a6.busy[0], self.a7.busy[0], self.a8.busy[0], self.a9.busy[0], self.a10.busy[0], self.a12.busy[0], self.a13.busy[0], self.a14.busy[0], self.a16.busy[0], self.a17.busy[0], self.a19.busy[0], self.a21.busy[0], self.a23.busy[0], self.a24.busy[0], self.a25.busy[0], self.a26.busy[0], self.a28.busy[0], self.a29.busy[0], self.a30.busy[0], self.a32.busy[0], self.a33.busy[0], self.a34.busy[0], self.a35.busy[0], self.a36.busy[0], self.a37.busy[0], self.a38.busy[0], self.a40.busy[0], self.a41.busy[0], self.a42.busy[0], self.a43.busy[0], self.a44.busy[0], self.a46.busy[0], self.a47.busy[0], self.a48.busy[0], self.a50.busy[0], self.a51.busy[0], self.a53.busy[0], self.a55.busy[0], self.a57.busy[0], self.a58.busy[0], self.a59.busy[0], self.a60.busy[0], self.a62.busy[0], self.a63.busy[0], self.a64.busy[0], self.a66.busy[0], self.a67.busy[0]]
		self.alu_res = Group(0, alus, alu_list)
		self.TR.PruneT(self.alu_res.BuildActive(),(0,1))

                mult_list = [self.ma5.busy[0], self.ma11.busy[0], self.ma15.busy[0], self.ma18.busy[0], self.ma20.busy[0], self.ma22.busy[0], self.ma27.busy[0], self.ma31.busy[0], self.ma39.busy[0], self.ma45.busy[0], self.ma49.busy[0], self.ma52.busy[0], self.ma54.busy[0], self.ma56.busy[0], self.ma61.busy[0], self.ma65.busy[0]]
		self.mult_res = Group(0, mults, mult_list)
		self.TR.PruneT(self.mult_res.BuildActive(),(0,1))

	def BuildMemory(self):
		self.ma22.BuildMemory(0,self.a23.accepted[0])
		self.a23.BuildMemory(0,self.a24.accepted[1])
		self.a41.BuildMemory(0,self.a42.accepted[0])
		self.a10.BuildMemory(0,self.ma11.accepted[0])
		self.ma31.BuildMemory(0,self.a32.accepted[0])
		self.ma11.BuildMemory(0,self.a12.accepted[0])
		self.ma39.BuildMemory(0,self.a40.accepted[0])
		self.ma49.BuildMemory(0,self.a50.accepted[0])
		self.a7.BuildMemory(0,self.a8.accepted[0])
		self.a28.BuildMemory(0,self.a29.accepted[0])
		self.a57.BuildMemory(0,self.a58.accepted[1])
		self.ma56.BuildMemory(0,self.a57.accepted[0])
		self.ma54.BuildMemory(0,self.a55.accepted[0])
		self.a60.BuildMemory(0,self.ma61.accepted[0])
		self.ma61.BuildMemory(0,self.a62.accepted[0])
		self.ma52.BuildMemory(0,self.a53.accepted[0])
		self.a62.BuildMemory(0,self.a63.accepted[0])
		self.a50.BuildMemory(0,self.a51.accepted[1])
		self.a47.BuildMemory(0,self.a48.accepted[0])
		self.ma15.BuildMemory(0,self.a16.accepted[0])
		self.a64.BuildMemory(0,self.ma65.accepted[0])
		self.ma65.BuildMemory(0,self.a66.accepted[0])
		self.a2.BuildMemory(0,self.a3.accepted[0])
		self.a47.BuildMemory(0,self.a46.accepted[1])
		self.a66.BuildMemory(0,self.a67.accepted[1])
		self.a16.BuildMemory(0,self.a17.accepted[1])
		self.ma45.BuildMemory(0,self.a46.accepted[0])
		self.ma18.BuildMemory(0,self.a19.accepted[0])
		self.a44.BuildMemory(0,self.ma45.accepted[0])
		self.ma20.BuildMemory(0,self.a21.accepted[0])
		self.ma5.BuildMemory(0,self.a6.accepted[0])
		self.a40.BuildMemory(0,self.a41.accepted[1])
		self.a13.BuildMemory(0,self.a12.accepted[1])
		self.a36.BuildMemory(0,self.a37.accepted[0])
		self.a6.BuildMemory(0,self.a7.accepted[1])
		self.a0.BuildMemory(0,self.a1.accepted[0])
		self.a34.BuildMemory(0,self.a35.accepted[0])
		self.a32.BuildMemory(0,self.a33.accepted[1])
		self.a30.BuildMemory(0,self.ma31.accepted[0])
		self.a13.BuildMemory(0,self.a14.accepted[0])
		self.a26.BuildMemory(0,self.ma27.accepted[0])
		self.ma27.BuildMemory(0,self.a28.accepted[0])
		self.a53.BuildMemory(0,self.a51.accepted[0])
		self.a36.BuildMemory(0,self.a38.accepted[0])
		self.a19.BuildMemory(0,self.a17.accepted[0])
		self.a57.BuildMemory(0,self.a55.accepted[1])
		self.a58.BuildMemory(0,self.a60.accepted[0])
		self.a34.BuildMemory(0,self.a36.accepted[0])
		self.a2.BuildMemory(0,self.a4.accepted[0])
		self.a12.BuildMemory(0,self.a14.accepted[1])
		self.a23.BuildMemory(0,self.a21.accepted[1])
		self.a24.BuildMemory(0,self.a26.accepted[0])
		self.a23.BuildMemory(0,self.a25.accepted[0])
		self.a57.BuildMemory(0,self.a59.accepted[0])
		self.a0.BuildMemory(0,self.a2.accepted[0])
		self.a46.BuildMemory(0,self.a48.accepted[1])
		self.a13.BuildMemory(0,self.a10.accepted[1])
		self.a26.BuildMemory(0,self.a29.accepted[1])
		self.a10.BuildMemory(0,self.a7.accepted[0])
		self.a64.BuildMemory(0,self.a67.accepted[0])
		self.a30.BuildMemory(0,self.a33.accepted[0])
		self.a6.BuildMemory(0,self.a9.accepted[1])
		self.a33.BuildMemory(0,self.a36.accepted[1])
		self.a40.BuildMemory(0,self.a37.accepted[1])
		self.a44.BuildMemory(0,self.a41.accepted[0])
		self.a60.BuildMemory(0,self.a63.accepted[1])
		self.a6.BuildMemory(0,self.a3.accepted[1])
		self.a40.BuildMemory(0,self.a43.accepted[1])
		self.a47.BuildMemory(0,self.a44.accepted[1])
		self.a12.BuildMemory(0,self.a8.accepted[1])
		self.a36.BuildMemory(0,self.a40.accepted[1])
		self.a2.BuildMemory(0,self.a6.accepted[1])
		self.a46.BuildMemory(0,self.a42.accepted[1])
		self.a25.BuildMemory(0,self.ma20.accepted[0])
		self.a10.BuildMemory(0,self.ma5.accepted[0])
		self.a44.BuildMemory(0,self.ma39.accepted[0])
		self.a59.BuildMemory(0,self.ma54.accepted[0])
		self.a4.BuildMemory(0,self.a10.accepted[0])
		self.a38.BuildMemory(0,self.a44.accepted[0])
		self.a50.BuildMemory(0,self.a43.accepted[0])
		self.a16.BuildMemory(0,self.a9.accepted[0])
		self.a14.BuildMemory(0,self.ma22.accepted[0])
		self.a48.BuildMemory(0,self.ma56.accepted[0])
		self.a3.BuildMemory(0,self.ma15.accepted[0])
		self.a46.BuildMemory(0,self.a58.accepted[0])
		self.a12.BuildMemory(0,self.a24.accepted[0])
		self.a37.BuildMemory(0,self.ma49.accepted[0])
		self.a50.BuildMemory(0,self.a35.accepted[1])
		self.a16.BuildMemory(0,self.a1.accepted[1])
		self.a0.BuildMemory(0,self.a16.accepted[1])
		self.a34.BuildMemory(0,self.a50.accepted[1])
		self.a35.BuildMemory(0,self.ma52.accepted[0])
		self.a17.BuildMemory(0,self.a34.accepted[0])
		self.a1.BuildMemory(0,self.ma18.accepted[0])
		self.a29.BuildMemory(0,self.a47.accepted[0])
		self.a9.BuildMemory(0,self.a30.accepted[0])
		self.a43.BuildMemory(0,self.a64.accepted[0])
		self.a21.BuildMemory(0,self.a47.accepted[1])
		self.a8.BuildMemory(0,self.a38.accepted[1])
		self.a55.BuildIMemory(0,self.a25.accepted[1])
		self.a32.BuildMemory(0,self.a64.accepted[1])
		self.a28.BuildMemory(0,self.a60.accepted[1])
		self.a55.BuildIMemory(0,self.a23.accepted[1])
		self.a28.BuildMemory(0,self.a62.accepted[1])
		self.a62.BuildIMemory(0,self.a28.accepted[1])
		self.a66.BuildIMemory(0,self.a32.accepted[1])
		self.a32.BuildMemory(0,self.a66.accepted[1])
		self.a66.BuildIMemory(0,self.a30.accepted[1])
		self.a21.BuildMemory(0,self.a57.accepted[1])
		self.a62.BuildIMemory(0,self.a26.accepted[1])
		self.a42.BuildIMemory(0,self.a4.accepted[1])
		self.a21.BuildMemory(0,self.a59.accepted[1])
		self.a55.BuildIMemory(0,self.a13.accepted[1])
		self.a63.BuildIMemory(0,self.a13.accepted[0])
		self.a51.BuildIMemory(0,self.a0.accepted[0])
		self.a67.BuildIMemory(0,self.a2.accepted[1])

                mem_list = [self.a0.memcare[0], self.a1.memcare[0], self.a2.memcare[0], self.a3.memcare[0], self.a4.memcare[0], self.ma5.memcare[0], self.a6.memcare[0], self.a7.memcare[0], self.a8.memcare[0], self.a9.memcare[0], self.a10.memcare[0], self.ma11.memcare[0], self.a12.memcare[0], self.a13.memcare[0], self.a14.memcare[0], self.ma15.memcare[0], self.a16.memcare[0], self.a17.memcare[0], self.ma18.memcare[0], self.a19.memcare[0], self.ma20.memcare[0], self.a21.memcare[0], self.ma22.memcare[0], self.a23.memcare[0], self.a24.memcare[0], self.a25.memcare[0], self.a26.memcare[0], self.ma27.memcare[0], self.a28.memcare[0], self.a29.memcare[0], self.a30.memcare[0], self.ma31.memcare[0], self.a32.memcare[0], self.a33.memcare[0], self.a34.memcare[0], self.a35.memcare[0], self.a36.memcare[0], self.a37.memcare[0], self.a38.memcare[0], self.ma39.memcare[0], self.a40.memcare[0], self.a41.memcare[0], self.a42.memcare[0], self.a43.memcare[0], self.a44.memcare[0], self.ma45.memcare[0], self.a46.memcare[0], self.a47.memcare[0], self.a48.memcare[0], self.ma49.memcare[0], self.a50.memcare[0], self.a51.memcare[0], self.ma52.memcare[0], self.a53.memcare[0], self.ma54.memcare[0], self.a55.memcare[0], self.ma56.memcare[0], self.a57.memcare[0], self.a58.memcare[0], self.a59.memcare[0], self.a60.memcare[0], self.ma61.memcare[0], self.a62.memcare[0], self.a63.memcare[0], self.a64.memcare[0], self.ma65.memcare[0], self.a66.memcare[0], self.a67.memcare[0]]
		self.mem_res = Group(0, registers, mem_list)
		self.TR.PruneT(self.mem_res.BuildActive(),(0,1))

bm = Top(0)
bm.BuildCompositeState(0)
bm.BuildRelation()
bm.TR.Info()
bm.TR.SetVarMap()
bm.BuildVectors((0,0),(0,1))
bm.TR.Info()
bm.TR.ReachabilityPrune(bm.taskstart[0],(0,1))
bm.TR.Collapse()
bm.TR.Info()
bm.BuildGroups()
bm.TR.Info()
bm.BuildMemory()
bm.TR.Info()
bm.pin = bm.a10
bm.tagdepth = 10
#bm.Reorder()
result = bm.DFSchedule()
result.Trace()
result.PrintTrace()


print os.times()











