#!/usr/bin/python -u
import sys
import os
from malib import *

outname = sys.argv[1]

if not outname == "term":
        print "Output to",outname
        sys.stdout = open(outname,"w")

print os.times()

class Top(Model):

	def __init__(self,parent):

		Model.__init__(self,parent)
		self.submodels = []

		self.a1 = COp1(self,1)
		self.a9 = COp1(self,0)
		self.m15 = COp2p(self,0)
		self.a23 = COp1(self,1)
		self.s24 = COp1(self,1)
		self.m16 = COp2p(self,0)
		self.a10 = COp1(self,0)
		self.a2 = COp1(self,1)
		self.a3 = COp1(self,1)
		self.s11 = COp1(self,0)
		self.m17 = COp2p(self,0)
		self.m18 = COp2p(self,0)
		self.s25 = COp1(self,1)
		self.a26 = COp1(self,1)
		self.m19 = COp2p(self,0)
		self.m20 = COp2p(self,0)
		self.s12 = COp1(self,0)
		self.a4 = COp1(self,1)

                self.io = COpRWIO(self,0)

		self.s5 = COp1(self,1)
		self.a27 = COp1(self,0)
		self.m31 = COp2p(self,0)
		self.m32 = COp2p(self,0)
		self.a39 = COp1(self,1)
		self.s42 = COp1(self,1)
		self.m37 = COp2p(self,0)
		self.m38 = COp2p(self,0)
		self.a30 = COp1(self,0)
		self.s8 = COp1(self,1)
		self.s29 = COp1(self,0)
		self.m35 = COp2p(self,0)
		self.m36 = COp2p(self,0)
		self.a40 = COp1(self,1)
		self.s41 = COp1(self,1)
		self.m33 = COp2p(self,0)
		self.m34 = COp2p(self,0)
		self.s28 = COp1(self,0)
		self.a21 = COp1(self,0)
		self.m13 = COp2p(self,0)
		self.m14 = COp2p(self,0)
		self.s7 = COp1(self,1)
		self.s6 = COp1(self,1)
		self.s22 = COp1(self,0)

		self.outtags = [self.s41, self.a40, self.s42, self.a39, self.a26, self.s25, self.s24, self.a23]

                self.AddNames()

	def BuildRelation(self):
		Model.BuildCompositeTR(self)
		set = []

		Enable(set,self.a1.known[0],self.a9.required[0])
		Enable(set,self.a2.known[0],self.a10.required[0])
		Enable(set,self.a3.known[0],self.s11.required[1])
		Enable(set,self.a4.known[0],self.s12.required[1])
		Enable(set,self.s7.known[0],self.m14.required[0])
		Enable(set,self.a9.known[0],self.m15.required[0])
		Enable(set,self.a10.known[0],self.m16.required[0])
		Enable(set,self.s11.known[0],self.m17.required[0])
		Enable(set,self.s12.known[0],self.m20.required[0])
		Enable(set,self.m13.known[0],self.a21.required[0])
		Enable(set,self.m15.known[0],self.a23.required[0])
		Enable(set,self.m16.known[0],self.s24.required[1])
		Enable(set,self.s5.known[0],self.a27.required[1])
		Enable(set,self.a21.known[0],self.s28.required[0])
		Enable(set,self.s8.known[0],self.s29.required[1])
		Enable(set,self.s8.known[0],self.a30.required[1])
		Enable(set,self.a27.known[0],self.m31.required[0])
		Enable(set,self.s28.known[0],self.m34.required[0])
		Enable(set,self.s29.known[0],self.m35.required[0])
		Enable(set,self.a30.known[0],self.m38.required[0])
		Enable(set,self.a3.known[0],self.a10.required[1])
		Enable(set,self.a2.known[0],self.s11.required[0])
		Enable(set,self.s11.known[0],self.m18.required[0])
		Enable(set,self.s12.known[0],self.m19.required[0])
		Enable(set,self.m14.known[0],self.a21.required[1])
		Enable(set,self.m16.known[0],self.a23.required[1])
		Enable(set,self.m15.known[0],self.s24.required[0])
		Enable(set,self.m17.known[0],self.s25.required[0])
		Enable(set,self.m19.known[0],self.s25.required[1])
		Enable(set,self.m18.known[0],self.a26.required[0])
		Enable(set,self.m20.known[0],self.a26.required[1])
		Enable(set,self.a27.known[0],self.m32.required[0])
		Enable(set,self.s28.known[0],self.m33.required[0])
		Enable(set,self.s29.known[0],self.m36.required[0])
		Enable(set,self.a30.known[0],self.m37.required[0])
		Enable(set,self.m31.known[0],self.a39.required[0])
		Enable(set,self.m37.known[0],self.a39.required[1])
		Enable(set,self.m33.known[0],self.a40.required[0])
		Enable(set,self.m35.known[0],self.a40.required[1])
		Enable(set,self.m34.known[0],self.s41.required[0])
		Enable(set,self.m36.known[0],self.s41.required[1])
		Enable(set,self.m32.known[0],self.s42.required[0])
		Enable(set,self.m38.known[0],self.s42.required[1])
		Enable(set,self.s6.known[0],self.m13.required[0])
		Enable(set,self.m14.known[0],self.s22.required[1])
		Enable(set,self.m13.known[0],self.s22.required[0])
		Enable(set,self.s22.known[0],self.s29.required[0])
		Enable(set,self.s22.known[0],self.a30.required[0])
		Enable(set,self.a4.known[0],self.a9.required[1])
		Enable(set,self.a1.known[0],self.s12.required[0])
		Enable(set,self.a21.known[0],self.a27.required[0])
		Enable(set,self.s5.known[0],self.s28.required[1])

		vec = List2Vec(set)
		self.TR[0].rel = self.TR[0].rel & vec.And()

		set = []

		Capacity(set,self.a1.known[0],self.a9.accepted[0])
		Capacity(set,self.a2.known[0],self.a10.accepted[0])
		Capacity(set,self.a3.known[0],self.s11.accepted[1])
		Capacity(set,self.a4.known[0],self.s12.accepted[1])
		Capacity(set,self.s7.known[0],self.m14.accepted[0])
		Capacity(set,self.a9.known[0],self.m15.accepted[0])
		Capacity(set,self.a10.known[0],self.m16.accepted[0])
		Capacity(set,self.s11.known[0],self.m17.accepted[0])
		Capacity(set,self.s12.known[0],self.m20.accepted[0])
		Capacity(set,self.m13.known[0],self.a21.accepted[0])
		Capacity(set,self.m15.known[0],self.a23.accepted[0])
		Capacity(set,self.m16.known[0],self.s24.accepted[1])
		Capacity(set,self.s5.known[0],self.a27.accepted[1])
		Capacity(set,self.a21.known[0],self.s28.accepted[0])
		Capacity(set,self.s8.known[0],self.s29.accepted[1])
		Capacity(set,self.s8.known[0],self.a30.accepted[1])
		Capacity(set,self.a27.known[0],self.m31.accepted[0])
		Capacity(set,self.s28.known[0],self.m34.accepted[0])
		Capacity(set,self.s29.known[0],self.m35.accepted[0])
		Capacity(set,self.a30.known[0],self.m38.accepted[0])
		Capacity(set,self.a3.known[0],self.a10.accepted[1])
		Capacity(set,self.a2.known[0],self.s11.accepted[0])
		Capacity(set,self.s11.known[0],self.m18.accepted[0])
		Capacity(set,self.s12.known[0],self.m19.accepted[0])
		Capacity(set,self.m14.known[0],self.a21.accepted[1])
		Capacity(set,self.m16.known[0],self.a23.accepted[1])
		Capacity(set,self.m15.known[0],self.s24.accepted[0])
		Capacity(set,self.m17.known[0],self.s25.accepted[0])
		Capacity(set,self.m19.known[0],self.s25.accepted[1])
		Capacity(set,self.m18.known[0],self.a26.accepted[0])
		Capacity(set,self.m20.known[0],self.a26.accepted[1])
		Capacity(set,self.a27.known[0],self.m32.accepted[0])
		Capacity(set,self.s28.known[0],self.m33.accepted[0])
		Capacity(set,self.s29.known[0],self.m36.accepted[0])
		Capacity(set,self.a30.known[0],self.m37.accepted[0])
		Capacity(set,self.m31.known[0],self.a39.accepted[0])
		Capacity(set,self.m37.known[0],self.a39.accepted[1])
		Capacity(set,self.m33.known[0],self.a40.accepted[0])
		Capacity(set,self.m35.known[0],self.a40.accepted[1])
		Capacity(set,self.m34.known[0],self.s41.accepted[0])
		Capacity(set,self.m36.known[0],self.s41.accepted[1])
		Capacity(set,self.m32.known[0],self.s42.accepted[0])
		Capacity(set,self.m38.known[0],self.s42.accepted[1])
		Capacity(set,self.s6.known[0],self.m13.accepted[0])
		Capacity(set,self.m14.known[0],self.s22.accepted[1])
		Capacity(set,self.m13.known[0],self.s22.accepted[0])
		Capacity(set,self.s22.known[0],self.s29.accepted[0])
		Capacity(set,self.s22.known[0],self.a30.accepted[0])
		Capacity(set,self.a4.known[0],self.a9.accepted[1])
		Capacity(set,self.a1.known[0],self.s12.accepted[0])
		Capacity(set,self.a21.known[0],self.a27.accepted[0])
		Capacity(set,self.s5.known[0],self.s28.accepted[1])
 
		vec = List2Vec(set)
		self.TR[0].rel = self.TR[0].rel & vec.And()


	def BuildGroups(self):

		allbounds = mgr.One()

                alu_list = [self.s5.busy[0], self.s6.busy[0], self.s7.busy[0], self.s8.busy[0], self.s11.busy[0], self.s12.busy[0], self.s22.busy[0], self.s24.busy[0], self.s25.busy[0], self.s28.busy[0], self.s29.busy[0], self.s41.busy[0], self.s42.busy[0], self.a1.busy[0], self.a2.busy[0], self.a3.busy[0], self.a4.busy[0], self.a9.busy[0], self.a10.busy[0], self.a21.busy[0], self.a23.busy[0], self.a26.busy[0], self.a27.busy[0], self.a30.busy[0], self.a39.busy[0], self.a40.busy[0]]
		self.alusub_res = Group(0, 2, alu_list)
		allbounds = allbounds & self.alusub_res.BuildActive()

                mult_list = [self.m13.busy[0], self.m14.busy[0], self.m15.busy[0], self.m16.busy[0], self.m17.busy[0], self.m18.busy[0], self.m19.busy[0], self.m20.busy[0], self.m31.busy[0], self.m32.busy[0], self.m33.busy[0], self.m34.busy[0], self.m35.busy[0], self.m36.busy[0], self.m37.busy[0], self.m38.busy[0]]
		self.mult_res = Group(0, 1, mult_list)
		allbounds = allbounds & self.mult_res.BuildActive()

                extio_list = [(self.a1.required[0], self.s8.required[0]), (self.a1.required[1], self.s8.required[1]), (self.a2.required[0], self.s7.required[0]), (self.a2.required[1], self.s7.required[1]), (self.a3.required[0], self.s6.required[0]), (self.a3.required[1], self.s6.required[1]), (self.a4.required[0], self.s5.required[0]), (self.a4.required[1], self.s5.required[1]), self.a23.produced[0], self.s24.produced[0], self.s25.produced[0], self.a26.produced[0], self.a39.produced[0], self.a40.produced[0], self.s41.produced[0], self.s42.produced[0]]
		self.extiobus_res = Group(0, 2, extio_list)
		allbounds = allbounds & self.extiobus_res.BuildActiveSetOR()
		
		
		## Includes manual terms from extinbus (ORed) and multiplier coefficients.
                trans_list = [(self.a9.required[0], self.s12.required[0], ), (self.a10.required[0], self.s11.required[0], ), (self.a10.required[1], self.s11.required[1], ), (self.a9.required[1], self.s12.required[1], ), (self.a27.required[1], self.s28.required[1], ), (self.a30.required[1], self.s29.required[1], ), (self.m17.required[0], self.m18.required[0], ), (self.m19.required[0], self.m20.required[0], ), (self.a21.required[0], self.s22.required[0], ), (self.a21.required[1], self.s22.required[1], ), (self.a23.required[0], self.s24.required[0], ), (self.a23.required[1], self.s24.required[1], ), (self.a27.required[0], self.s28.required[0], ), (self.a30.required[0], self.s29.required[0], ), (self.m31.required[0], self.m32.required[0], ), (self.m33.required[0], self.m34.required[0], ), (self.m35.required[0], self.m36.required[0], ), (self.m37.required[0], self.m38.required[0], ),
                              (self.a39.required[0], ), (self.s42.required[0], ), (self.a40.required[0], ), (self.s41.required[0], ), (self.a40.required[1], ), (self.s41.required[1], ), (self.a39.required[1], ), (self.s42.required[1], ), (self.m13.required[0], ), (self.m14.required[0], ), (self.m16.required[0], ), (self.s25.required[0], ), (self.a26.required[0], ), (self.s25.required[1], ), (self.a26.required[1], ), (self.m15.required[0], ),
                              (self.a1.required[0], self.s8.required[0]), (self.a1.required[1], self.s8.required[1]), (self.a2.required[0], self.s7.required[0]), (self.a2.required[1], self.s7.required[1]), (self.a3.required[0], self.s6.required[0]), (self.a3.required[1], self.s6.required[1]), (self.a4.required[0], self.s5.required[0]), (self.a4.required[1], self.s5.required[1]),
                              self.a1.produced[0], self.a2.produced[0], self.a3.produced[0], self.a4.produced[0], self.s5.produced[0], self.s6.produced[0], self.s7.produced[0], self.s8.produced[0], self.a9.produced[0], self.a10.produced[0], self.s11.produced[0], self.s12.produced[0], self.m13.produced[0], self.m14.produced[0], self.m15.produced[0], self.m16.produced[0], self.m17.produced[0], self.m18.produced[0], self.m19.produced[0], self.m20.produced[0], self.a21.produced[0], self.s22.produced[0], self.a23.produced[0], self.s24.produced[0], self.s25.produced[0], self.a26.produced[0], self.a27.produced[0], self.s28.produced[0], self.s29.produced[0], self.a30.produced[0], self.m31.produced[0], self.m32.produced[0], self.m33.produced[0], self.m34.produced[0], self.m35.produced[0], self.m36.produced[0], self.m37.produced[0], self.m38.produced[0], self.a39.produced[0], self.a40.produced[0], self.s41.produced[0], self.s42.produced[0],
                              self.m13.required[1], self.m14.required[1], self.m31.required[1], self.m32.required[1], self.m33.required[1], self.m34.required[1], self.m35.required[1], self.m36.required[1], self.m37.required[1], self.m38.required[1], self.m15.required[1], self.m16.required[1], self.m17.required[1], self.m18.required[1], self.m19.required[1], self.m20.required[1] ]

		self.transaction_res = Group(0,  7, trans_list)
		allbounds = allbounds & self.transaction_res.BuildActiveSetOR()

		self.TR.PruneT(allbounds, (0,1) )


	def BuildMemory(self):
		self.a1.BuildMemory(0,self.a9.accepted[0])
		self.a2.BuildMemory(0,self.a10.accepted[0])
		self.a3.BuildMemory(0,self.s11.accepted[1])
		self.a4.BuildMemory(0,self.s12.accepted[1])
		self.s7.BuildMemory(0,self.m14.accepted[0])
		self.a9.BuildMemory(0,self.m15.accepted[0])
		self.a10.BuildMemory(0,self.m16.accepted[0])
		self.s11.BuildMemory(0,self.m17.accepted[0])
		self.s12.BuildMemory(0,self.m20.accepted[0])
		self.m13.BuildMemory(0,self.a21.accepted[0])
		self.m15.BuildMemory(0,self.a23.accepted[0])
		self.m16.BuildMemory(0,self.s24.accepted[1])
		self.s5.BuildMemory(0,self.a27.accepted[1])
		self.a21.BuildMemory(0,self.s28.accepted[0])
		self.s8.BuildMemory(0,self.s29.accepted[1])
		self.s8.BuildMemory(0,self.a30.accepted[1])
		self.a27.BuildMemory(0,self.m31.accepted[0])
		self.s28.BuildMemory(0,self.m34.accepted[0])
		self.s29.BuildMemory(0,self.m35.accepted[0])
		self.a30.BuildMemory(0,self.m38.accepted[0])
		self.a3.BuildMemory(0,self.a10.accepted[1])
		self.a2.BuildMemory(0,self.s11.accepted[0])
		self.s11.BuildMemory(0,self.m18.accepted[0])
		self.s12.BuildMemory(0,self.m19.accepted[0])
		self.m14.BuildMemory(0,self.a21.accepted[1])
		self.m16.BuildMemory(0,self.a23.accepted[1])
		self.m15.BuildMemory(0,self.s24.accepted[0])
		self.m17.BuildMemory(0,self.s25.accepted[0])
		self.m19.BuildMemory(0,self.s25.accepted[1])
		self.m18.BuildMemory(0,self.a26.accepted[0])
		self.m20.BuildMemory(0,self.a26.accepted[1])
		self.a27.BuildMemory(0,self.m32.accepted[0])
		self.s28.BuildMemory(0,self.m33.accepted[0])
		self.s29.BuildMemory(0,self.m36.accepted[0])
		self.a30.BuildMemory(0,self.m37.accepted[0])
		self.m31.BuildMemory(0,self.a39.accepted[0])
		self.m37.BuildMemory(0,self.a39.accepted[1])
		self.m33.BuildMemory(0,self.a40.accepted[0])
		self.m35.BuildMemory(0,self.a40.accepted[1])
		self.m34.BuildMemory(0,self.s41.accepted[0])
		self.m36.BuildMemory(0,self.s41.accepted[1])
		self.m32.BuildMemory(0,self.s42.accepted[0])
		self.m38.BuildMemory(0,self.s42.accepted[1])
		self.s6.BuildMemory(0,self.m13.accepted[0])
		self.m14.BuildMemory(0,self.s22.accepted[1])
		self.m13.BuildMemory(0,self.s22.accepted[0])
		self.s22.BuildMemory(0,self.s29.accepted[0])
		self.s22.BuildMemory(0,self.a30.accepted[0])
		self.a4.BuildMemory(0,self.a9.accepted[1])
		self.a1.BuildMemory(0,self.s12.accepted[0])
		self.a21.BuildMemory(0,self.a27.accepted[0])
		self.s5.BuildMemory(0,self.s28.accepted[1])

                mem_list = [self.a1.memcare[0], self.a2.memcare[0], self.a3.memcare[0], self.a4.memcare[0], self.s5.memcare[0], self.s6.memcare[0], self.s7.memcare[0], self.s8.memcare[0], self.a9.memcare[0], self.a10.memcare[0], self.s11.memcare[0], self.s12.memcare[0], self.m13.memcare[0], self.m14.memcare[0], self.m15.memcare[0], self.m16.memcare[0], self.m17.memcare[0], self.m18.memcare[0], self.m19.memcare[0], self.m20.memcare[0], self.a21.memcare[0], self.s22.memcare[0], self.a23.memcare[0], self.s24.memcare[0], self.s25.memcare[0], self.a26.memcare[0], self.a27.memcare[0], self.s28.memcare[0], self.s29.memcare[0], self.a30.memcare[0], self.m31.memcare[0], self.m32.memcare[0], self.m33.memcare[0], self.m34.memcare[0], self.m35.memcare[0], self.m36.memcare[0], self.m37.memcare[0], self.m38.memcare[0], self.a39.memcare[0], self.a40.memcare[0], self.s41.memcare[0], self.s42.memcare[0]]
		self.mem_res = Group(0, 8, mem_list)
		self.TR.PruneT(self.mem_res.BuildActive(),(0,1))
		##self.constraints.append(self.mem_res.BuildActive())

	def BuildOrder(self):
		set = []

		## Ordered inputs
		Enable(set,self.s5.accepted[0], self.s6.required[0]) ## A7,A0 before A6,A1
		Enable(set,self.a4.accepted[0], self.s6.required[0])
		Enable(set,self.s5.accepted[0], self.a3.required[0])
		Enable(set,self.a4.accepted[0], self.a3.required[0])

		Enable(set,self.s6.accepted[0], self.s7.required[0]) ## A6,A1 before A5,A2
		Enable(set,self.a3.accepted[0], self.s7.required[0])
		Enable(set,self.s6.accepted[0], self.a2.required[0])
		Enable(set,self.a3.accepted[0], self.a2.required[0])

		Enable(set,self.s7.accepted[0], self.s8.required[0]) ## A5,A2 before A4,A3
		Enable(set,self.a2.accepted[0], self.s8.required[0])
		Enable(set,self.s7.accepted[0], self.a1.required[0])
		Enable(set,self.a2.accepted[0], self.a1.required[0])

		IEnable(set,self.s8.accepted[0], self.s5.required[0]) ## A4,A3 before A7,A0 (Inverted)
		IEnable(set,self.a1.accepted[0], self.s5.required[0])
		IEnable(set,self.s8.accepted[0], self.a4.required[0])
		IEnable(set,self.a1.accepted[0], self.a4.required[0])
		
		## Ordered outputs
		Enable(set,self.a23.known[0], self.s42.produced[0]) ## F0 before F7
		Enable(set,self.s42.known[0], self.s25.produced[0]) ## F7 before F6
		Enable(set,self.s25.known[0], self.a39.produced[0]) ## F6 before F1
		Enable(set,self.a39.known[0], self.a26.produced[0]) ## F1 before F2
		Enable(set,self.a26.known[0], self.a40.produced[0]) ## F2 before F5
		Enable(set,self.a40.known[0], self.s24.produced[0]) ## F5 before F4
		Enable(set,self.s24.known[0], self.s41.produced[0]) ## F4 before F3
		IEnable(set,self.s41.known[0], self.a23.produced[0]) ## F3 before F0 (Inverted)

		print "First stage order done"
		vec = List2Vec(set)
		self.TR[1].rel = self.TR[1].rel & vec.And()

	def BuildPartialOrder(self):
		set = []
	
		PartialOrder(set,self.s5.accepted[0], self.s6.required[0]) ## A7,A0 before A6,A1
		PartialOrder(set,self.a4.accepted[0], self.s6.required[0])
		PartialOrder(set,self.s5.accepted[0], self.a3.required[0])
		PartialOrder(set,self.a4.accepted[0], self.a3.required[0])

		PartialOrder(set,self.s6.accepted[0], self.s7.required[0]) ## A6,A1 before A5,A2
		PartialOrder(set,self.a3.accepted[0], self.s7.required[0])
		PartialOrder(set,self.s6.accepted[0], self.a2.required[0])
		PartialOrder(set,self.a3.accepted[0], self.a2.required[0])

		PartialOrder(set,self.s7.accepted[0], self.s8.required[0]) ## A5,A2 before A4,A3
		PartialOrder(set,self.a2.accepted[0], self.s8.required[0])
		PartialOrder(set,self.s7.accepted[0], self.a1.required[0])
		PartialOrder(set,self.a2.accepted[0], self.a1.required[0])

		IPartialOrder(set,self.s8.accepted[0], self.s5.required[0]) ## A4,A3 before A7,A0 (Inverted)
		IPartialOrder(set,self.a1.accepted[0], self.s5.required[0])
		IPartialOrder(set,self.s8.accepted[0], self.a4.required[0])
		IPartialOrder(set,self.a1.accepted[0], self.a4.required[0])
	
		## Partial order on outputs
		PartialOrder(set,self.a39.accepted[0], self.s42.required[0])
		IPartialOrder(set,self.s42.accepted[0], self.a39.required[0])

		PartialOrder(set,self.s41.accepted[0], self.a40.required[0])
		IPartialOrder(set,self.a40.accepted[0], self.s41.required[0])

		PartialOrder(set,self.a26.accepted[0], self.s25.required[0])
		IPartialOrder(set,self.s25.accepted[0], self.a26.required[0])

		PartialOrder(set,self.a23.accepted[0], self.s24.required[0])
		IPartialOrder(set,self.s24.accepted[0], self.a23.required[0])

		print "Partial order built"
		vec = List2Vec(set)
		self.TR[1].rel = self.TR[1].rel & vec.And()
		
	def BuildReverse(self):
		set = []

		bcompleted = (self.s42.known[0], self.s41.known[0], self.a40.known[0], self.a39.known[0])
		tcompleted = (self.a26.known[0], self.s25.known[0], self.s24.known[0], self.a23.known[0])

		IEnable(set, bcompleted, self.s5.required[0])
		IEnable(set, tcompleted, self.s5.required[0])
		IEnable(set, bcompleted, self.s6.required[0])
		IEnable(set, tcompleted, self.s6.required[0])
		IEnable(set, bcompleted, self.s7.required[0])
		IEnable(set, tcompleted, self.s7.required[0])
		IEnable(set, bcompleted, self.s8.required[0])
		IEnable(set, tcompleted, self.s8.required[0])

		IEnable(set, bcompleted, self.a1.required[0])
		IEnable(set, tcompleted, self.a1.required[0])
		IEnable(set, bcompleted, self.a2.required[0])
		IEnable(set, tcompleted, self.a2.required[0])
		IEnable(set, bcompleted, self.a3.required[0])
		IEnable(set, tcompleted, self.a3.required[0])
		IEnable(set, bcompleted, self.a4.required[0])
		IEnable(set, tcompleted, self.a4.required[0])

		print "Single instance done"
		vec = List2Vec(set)
		self.TR[1].rel = self.TR[1].rel & vec.And()


        def BuildIOProtocol(self):

		inlist =  (self.a1.required[0], self.s8.required[0], self.a2.required[0], self.s7.required[0], self.a3.required[0], self.s6.required[0],  self.a4.required[0], self.s5.required[0])

		term = mgr.Zero()
		for itemo in inlist:
			for itemi in itemo:
				term = term + itemi

		const1 = term >> (self.io.required[0][0] + self.io.required[0][1])
		const2 = (self.io.required[0][0] + self.io.required[0][1]) >> term
		term = const1  & const2
		self.TR.PruneT(term,(0,1))
		
		outlist = (self.a23.produced[0], self.s24.produced[0], self.s25.produced[0], self.a26.produced[0], self.a39.produced[0], self.a40.produced[0], self.s41.produced[0], self.s42.produced[0])

		term = mgr.Zero()
		for itemo in outlist:
			for itemi in itemo:
				term = term + itemi

		const1 = term >> (self.io.produced[0][0] + self.io.produced[0][1])
		const2 = (self.io.produced[0][0] + self.io.produced[0][1]) >> term
		term = const1  & const2
		self.TR.PruneT(term,(0,1))



bm = Top(0)
bm.BuildCompositeState(0)
bm.BuildRelation()
bm.BuildPartialOrder()
bm.TR.Info()
bm.TR.SetVarMap()
bm.BuildVectors((0,0),(0,1))
bm.TR.Info()
bm.TR.ReachabilityPrune(bm.taskstart[0],(0,1))
bm.TR.Collapse()
bm.TR.Info()

print "Applying memory constraints"
bm.BuildMemory()
bm.TR.Info()
print "Applying protocol constraints"
bm.BuildIOProtocol()
bm.TR.Info()
print "Applying resource constraints"
bm.BuildGroups()
bm.TR.Info()

bm.pin = bm.s22
bm.tagdepth = 5
bm.Reorder()
result = bm.DFSchedule()
result.Trace()
result.PrintTrace()

print os.times()


