#!/usr/bin/python -u
import sys
import os
from malib import *

## Note: this schedule is two EWFs so the latency for one EWF is half the total latency

outname = sys.argv[1]

if not outname == "term":
        print "Output to",outname
        sys.stdout = open(outname,"w")

alus = int(sys.argv[2])
mults = int(sys.argv[3])
ioports = int(sys.argv[4])


print os.times()

class Top(Model):

	def __init__(self,parent):

		Model.__init__(self,parent)
		self.submodels = []

		self.io0 = COp1(self,2)
		self.a1 = COp1(self,1)
		self.a2 = COp1(self,1)
		self.a3 = COp1(self,2)
		self.a4 = COp1(self,1)
		self.a5 = COp1(self,0)
		self.ma6 = COp2p(self,0)
		self.a7 = COp1(self,0)
		self.a8 = COp1(self,0)
		self.a9 = COp1(self,0)
		self.a10 = COp1(self,2)
		self.a11 = COp1(self,0)
		self.ma12 = COp2p(self,0)
		self.a13 = COp1(self,1)
		self.a14 = COp1(self,1)
		self.a15 = COp1(self,0)
		self.ma16 = COp2p(self,1)
		self.a17 = COp1(self,1)
		self.a18 = COp1(self,1)
		self.ma19 = COp2p(self,1)
		self.a20 = COp1(self,0)
		self.ma21 = COp2p(self,2)
		self.a22 = COp1(self,0)
		self.ma23 = COp2p(self,0)
		self.a24 = COp1(self,0)
		self.a25 = COp1(self,1)
		self.a26 = COp1(self,0)
		self.a27 = COp1(self,0)
		self.ma28 = COp2p(self,0)
		self.a29 = COp1(self,0)
		self.a30 = COp1(self,1)
		self.a31 = COp1(self,2)
		self.ma32 = COp2p(self,0)
		self.a33 = COp1(self,0)
		self.a34 = COp1(self,2)
		self.io35 = COp1(self,2)
		self.a36 = COp1(self,1)
		self.a37 = COp1(self,1)
		self.a38 = COp1(self,2)
		self.a39 = COp1(self,1)
		self.a40 = COp1(self,0)
		self.ma41 = COp2p(self,0)
		self.a42 = COp1(self,0)
		self.a43 = COp1(self,0)
		self.a44 = COp1(self,0)
		self.a45 = COp1(self,2)
		self.a46 = COp1(self,0)
		self.ma47 = COp2p(self,0)
		self.a48 = COp1(self,1)
		self.a49 = COp1(self,1)
		self.a50 = COp1(self,0)
		self.ma51 = COp2p(self,1)
		self.a52 = COp1(self,1)
		self.a53 = COp1(self,1)
		self.ma54 = COp2p(self,1)
		self.a55 = COp1(self,0)
		self.ma56 = COp2p(self,2)
		self.a57 = COp1(self,0)
		self.ma58 = COp2p(self,0)
		self.a59 = COp1(self,0)
		self.a60 = COp1(self,1)
		self.a61 = COp1(self,0)
		self.a62 = COp1(self,0)
		self.ma63 = COp2p(self,0)
		self.a64 = COp1(self,0)
		self.a65 = COp1(self,1)
		self.a66 = COp1(self,2)
		self.ma67 = COp2p(self,0)
		self.a68 = COp1(self,0)
		self.a69 = COp1(self,2)

		self.outtags = [self.a9, self.a18, self.ma21, self.a22, self.a29, self.a30, self.a33, self.a34, self.a44, self.a53, self.ma56, self.a57, self.a64, self.a65, self.a68, self.a69, ]
                self.AddNames()

	def BuildRelation(self):
		Model.BuildCompositeTR(self)
		set = []

		IEnable(set,self.a33.known[0],self.a33.required[1])
		IEnable(set,self.a29.known[0],self.a29.required[1])
		IEnable(set,self.a64.known[0],self.a64.required[1])
		IEnable(set,self.a68.known[0],self.a68.required[1])
		Enable(set,self.ma67.known[0],self.a68.required[0])
		Enable(set,self.a31.known[0],self.ma32.required[0])
		Enable(set,self.ma51.known[0],self.a52.required[0])
		Enable(set,self.ma28.known[0],self.a29.required[0])
		Enable(set,self.a62.known[0],self.ma63.required[0])
		Enable(set,self.ma32.known[0],self.a33.required[0])
		Enable(set,self.a52.known[0],self.a53.required[1])
		Enable(set,self.ma12.known[0],self.a13.required[0])
		Enable(set,self.a42.known[0],self.a43.required[1])
		Enable(set,self.a38.known[0],self.a39.required[0])
		Enable(set,self.a49.known[0],self.a48.required[1])
		Enable(set,self.a59.known[0],self.a60.required[1])
		Enable(set,self.ma58.known[0],self.a59.required[0])
		Enable(set,self.a7.known[0],self.a8.required[1])
		Enable(set,self.ma6.known[0],self.a7.required[0])
		Enable(set,self.ma63.known[0],self.a64.required[0])
		Enable(set,self.a64.known[0],self.a65.required[0])
		Enable(set,self.io0.known[0],self.a1.required[1])
		Enable(set,self.ma56.known[0],self.a57.required[0])
		Enable(set,self.ma54.known[0],self.a55.required[0])
		Enable(set,self.a66.known[0],self.ma67.required[0])
		Enable(set,self.a1.known[0],self.a2.required[0])
		Enable(set,self.a3.known[0],self.a4.required[0])
		Enable(set,self.a68.known[0],self.a69.required[1])
		Enable(set,self.a49.known[0],self.a50.required[0])
		Enable(set,self.ma47.known[0],self.a48.required[0])
		Enable(set,self.a17.known[0],self.a18.required[1])
		Enable(set,self.a46.known[0],self.ma47.required[0])
		Enable(set,self.ma19.known[0],self.a20.required[0])
		Enable(set,self.a11.known[0],self.ma12.required[0])
		Enable(set,self.a14.known[0],self.a15.required[0])
		Enable(set,self.ma21.known[0],self.a22.required[0])
		Enable(set,self.a43.known[0],self.a44.required[0])
		Enable(set,self.ma41.known[0],self.a42.required[0])
		Enable(set,self.ma23.known[0],self.a24.required[0])
		Enable(set,self.a14.known[0],self.a13.required[1])
		Enable(set,self.a36.known[0],self.a37.required[0])
		Enable(set,self.a24.known[0],self.a25.required[1])
		Enable(set,self.io35.known[0],self.a36.required[1])
		Enable(set,self.a8.known[0],self.a9.required[0])
		Enable(set,self.a33.known[0],self.a34.required[1])
		Enable(set,self.a29.known[0],self.a30.required[0])
		Enable(set,self.a27.known[0],self.ma28.required[0])
		Enable(set,self.ma16.known[0],self.a17.required[0])
		Enable(set,self.a13.known[0],self.a15.required[1])
		Enable(set,self.a24.known[0],self.a22.required[1])
		Enable(set,self.a60.known[0],self.a62.required[0])
		Enable(set,self.a3.known[0],self.a5.required[0])
		IEnable(set,self.a29.known[0],self.a27.required[1])
		IEnable(set,self.a68.known[0],self.a66.required[1])
		Enable(set,self.a25.known[0],self.a27.required[0])
		Enable(set,self.a24.known[0],self.a26.required[0])
		Enable(set,self.a36.known[0],self.a38.required[0])
		Enable(set,self.a1.known[0],self.a3.required[0])
		IEnable(set,self.a22.known[0],self.a24.required[1])
		Enable(set,self.a38.known[0],self.a40.required[0])
		IEnable(set,self.a33.known[0],self.a31.required[1])
		Enable(set,self.a59.known[0],self.a61.required[0])
		Enable(set,self.a20.known[0],self.a18.required[0])
		IEnable(set,self.a57.known[0],self.a59.required[1])
		IEnable(set,self.a64.known[0],self.a62.required[1])
		Enable(set,self.a48.known[0],self.a50.required[1])
		Enable(set,self.a59.known[0],self.a57.required[1])
		Enable(set,self.a55.known[0],self.a53.required[0])
		Enable(set,self.a62.known[0],self.a65.required[1])
		Enable(set,self.a7.known[0],self.a4.required[1])
		Enable(set,self.a49.known[0],self.a46.required[1])
		Enable(set,self.a27.known[0],self.a30.required[1])
		Enable(set,self.a31.known[0],self.a34.required[0])
		Enable(set,self.a42.known[0],self.a39.required[1])
		Enable(set,self.a46.known[0],self.a43.required[0])
		Enable(set,self.a14.known[0],self.a11.required[1])
		Enable(set,self.a7.known[0],self.a10.required[1])
		Enable(set,self.a42.known[0],self.a45.required[1])
		Enable(set,self.a66.known[0],self.a69.required[0])
		Enable(set,self.a11.known[0],self.a8.required[0])
		Enable(set,self.a48.known[0],self.a44.required[1])
		IEnable(set,self.a9.known[0],self.a5.required[1])
		IEnable(set,self.a22.known[0],self.a26.required[1])
		Enable(set,self.a3.known[0],self.a7.required[1])
		IEnable(set,self.a44.known[0],self.a40.required[1])
		Enable(set,self.a38.known[0],self.a42.required[1])
		Enable(set,self.a13.known[0],self.a9.required[1])
		IEnable(set,self.a57.known[0],self.a61.required[1])
		Enable(set,self.a46.known[0],self.ma41.required[0])
		Enable(set,self.a11.known[0],self.ma6.required[0])
		Enable(set,self.a26.known[0],self.ma21.required[0])
		Enable(set,self.a61.known[0],self.ma56.required[1])
		Enable(set,self.a40.known[0],self.a46.required[0])
		Enable(set,self.a5.known[0],self.a11.required[0])
		Enable(set,self.a17.known[0],self.a10.required[0])
		Enable(set,self.a52.known[0],self.a45.required[0])
		Enable(set,self.a15.known[0],self.ma23.required[0])
		Enable(set,self.a50.known[0],self.ma58.required[0])
		IEnable(set,self.a22.known[0],self.a14.required[1])
		IEnable(set,self.a57.known[0],self.a49.required[1])
		Enable(set,self.a48.known[0],self.a60.required[0])


		vec = List2Vec(set)
		self.TR[0].rel = self.TR[0].rel & vec.And()

		set = []

		Enable(set,self.a4.known[0],self.ma16.required[0])
		Enable(set,self.a13.known[0],self.a25.required[0])
		Enable(set,self.a39.known[0],self.ma51.required[0])
		Enable(set,self.a52.known[0],self.a37.required[1])
		Enable(set,self.a17.known[0],self.a2.required[1])
		Enable(set,self.a36.known[0],self.a52.required[1])
		IEnable(set,self.a65.known[0],self.a49.required[0])
		IEnable(set,self.a30.known[0],self.a14.required[0])
		Enable(set,self.a1.known[0],self.a17.required[1])
		IEnable(set,self.a53.known[0],self.a36.required[0])
		Enable(set,self.a2.known[0],self.ma19.required[0])
		IEnable(set,self.a18.known[0],self.a1.required[0])
		Enable(set,self.a37.known[0],self.ma54.required[0])
		Enable(set,self.a10.known[0],self.a31.required[0])


		vec = List2Vec(set)
		self.TR[1].rel = self.TR[1].rel & vec.And()

		set = []

		Enable(set,self.a45.known[0],self.a66.required[0])
		IEnable(set,self.a69.known[0],self.a38.required[1])
		IEnable(set,self.a34.known[0],self.a3.required[1])
		IEnable(set,self.ma56.known[0],self.ma21.required[1])
		IEnable(set,self.io35.known[0],self.io0.required[0])
		Enable(set,self.io0.known[0],self.io35.required[0])
		Enable(set,self.ma21.known[0],self.ma56.required[0])


		vec = List2Vec(set)
		self.TR[2].rel = self.TR[2].rel & vec.And()

		set = []

		ICapacity(set,self.a33.known[0],self.a33.accepted[1])
		ICapacity(set,self.a29.known[0],self.a29.accepted[1])
		ICapacity(set,self.a64.known[0],self.a64.accepted[1])
		ICapacity(set,self.a68.known[0],self.a68.accepted[1])
		Capacity(set,self.ma67.known[0],self.a68.accepted[0])
		Capacity(set,self.a31.known[0],self.ma32.accepted[0])
		Capacity(set,self.ma51.known[0],self.a52.accepted[0])
		Capacity(set,self.ma28.known[0],self.a29.accepted[0])
		Capacity(set,self.a62.known[0],self.ma63.accepted[0])
		Capacity(set,self.ma32.known[0],self.a33.accepted[0])
		Capacity(set,self.a52.known[0],self.a53.accepted[1])
		Capacity(set,self.ma12.known[0],self.a13.accepted[0])
		Capacity(set,self.a42.known[0],self.a43.accepted[1])
		Capacity(set,self.a38.known[0],self.a39.accepted[0])
		Capacity(set,self.a49.known[0],self.a48.accepted[1])
		Capacity(set,self.a59.known[0],self.a60.accepted[1])
		Capacity(set,self.ma58.known[0],self.a59.accepted[0])
		Capacity(set,self.a7.known[0],self.a8.accepted[1])
		Capacity(set,self.ma6.known[0],self.a7.accepted[0])
		Capacity(set,self.ma63.known[0],self.a64.accepted[0])
		Capacity(set,self.a64.known[0],self.a65.accepted[0])
		Capacity(set,self.io0.known[0],self.a1.accepted[1])
		Capacity(set,self.ma56.known[0],self.a57.accepted[0])
		Capacity(set,self.ma54.known[0],self.a55.accepted[0])
		Capacity(set,self.a66.known[0],self.ma67.accepted[0])
		Capacity(set,self.a1.known[0],self.a2.accepted[0])
		Capacity(set,self.a3.known[0],self.a4.accepted[0])
		Capacity(set,self.a68.known[0],self.a69.accepted[1])
		Capacity(set,self.a49.known[0],self.a50.accepted[0])
		Capacity(set,self.ma47.known[0],self.a48.accepted[0])
		Capacity(set,self.a17.known[0],self.a18.accepted[1])
		Capacity(set,self.a46.known[0],self.ma47.accepted[0])
		Capacity(set,self.ma19.known[0],self.a20.accepted[0])
		Capacity(set,self.a11.known[0],self.ma12.accepted[0])
		Capacity(set,self.a14.known[0],self.a15.accepted[0])
		Capacity(set,self.ma21.known[0],self.a22.accepted[0])
		Capacity(set,self.a43.known[0],self.a44.accepted[0])
		Capacity(set,self.ma41.known[0],self.a42.accepted[0])
		Capacity(set,self.ma23.known[0],self.a24.accepted[0])
		Capacity(set,self.a14.known[0],self.a13.accepted[1])
		Capacity(set,self.a36.known[0],self.a37.accepted[0])
		Capacity(set,self.a24.known[0],self.a25.accepted[1])
		Capacity(set,self.io35.known[0],self.a36.accepted[1])
		Capacity(set,self.a8.known[0],self.a9.accepted[0])
		Capacity(set,self.a33.known[0],self.a34.accepted[1])
		Capacity(set,self.a29.known[0],self.a30.accepted[0])
		Capacity(set,self.a27.known[0],self.ma28.accepted[0])
		Capacity(set,self.ma16.known[0],self.a17.accepted[0])
		Capacity(set,self.a13.known[0],self.a15.accepted[1])
		Capacity(set,self.a24.known[0],self.a22.accepted[1])
		Capacity(set,self.a60.known[0],self.a62.accepted[0])
		Capacity(set,self.a3.known[0],self.a5.accepted[0])
		ICapacity(set,self.a29.known[0],self.a27.accepted[1])
		ICapacity(set,self.a68.known[0],self.a66.accepted[1])
		Capacity(set,self.a25.known[0],self.a27.accepted[0])
		Capacity(set,self.a24.known[0],self.a26.accepted[0])
		Capacity(set,self.a36.known[0],self.a38.accepted[0])
		Capacity(set,self.a1.known[0],self.a3.accepted[0])
		ICapacity(set,self.a22.known[0],self.a24.accepted[1])
		Capacity(set,self.a38.known[0],self.a40.accepted[0])
		ICapacity(set,self.a33.known[0],self.a31.accepted[1])
		Capacity(set,self.a59.known[0],self.a61.accepted[0])
		Capacity(set,self.a20.known[0],self.a18.accepted[0])
		ICapacity(set,self.a57.known[0],self.a59.accepted[1])
		ICapacity(set,self.a64.known[0],self.a62.accepted[1])
		Capacity(set,self.a48.known[0],self.a50.accepted[1])
		Capacity(set,self.a59.known[0],self.a57.accepted[1])
		Capacity(set,self.a55.known[0],self.a53.accepted[0])
		Capacity(set,self.a62.known[0],self.a65.accepted[1])
		Capacity(set,self.a7.known[0],self.a4.accepted[1])
		Capacity(set,self.a49.known[0],self.a46.accepted[1])
		Capacity(set,self.a27.known[0],self.a30.accepted[1])
		Capacity(set,self.a31.known[0],self.a34.accepted[0])
		Capacity(set,self.a42.known[0],self.a39.accepted[1])
		Capacity(set,self.a46.known[0],self.a43.accepted[0])
		Capacity(set,self.a14.known[0],self.a11.accepted[1])
		Capacity(set,self.a7.known[0],self.a10.accepted[1])
		Capacity(set,self.a42.known[0],self.a45.accepted[1])
		Capacity(set,self.a66.known[0],self.a69.accepted[0])
		Capacity(set,self.a11.known[0],self.a8.accepted[0])
		Capacity(set,self.a48.known[0],self.a44.accepted[1])
		ICapacity(set,self.a9.known[0],self.a5.accepted[1])
		ICapacity(set,self.a22.known[0],self.a26.accepted[1])
		Capacity(set,self.a3.known[0],self.a7.accepted[1])
		ICapacity(set,self.a44.known[0],self.a40.accepted[1])
		Capacity(set,self.a38.known[0],self.a42.accepted[1])
		Capacity(set,self.a13.known[0],self.a9.accepted[1])
		ICapacity(set,self.a57.known[0],self.a61.accepted[1])
		Capacity(set,self.a46.known[0],self.ma41.accepted[0])
		Capacity(set,self.a11.known[0],self.ma6.accepted[0])
		Capacity(set,self.a26.known[0],self.ma21.accepted[0])
		Capacity(set,self.a61.known[0],self.ma56.accepted[1])
		Capacity(set,self.a40.known[0],self.a46.accepted[0])
		Capacity(set,self.a5.known[0],self.a11.accepted[0])
		Capacity(set,self.a17.known[0],self.a10.accepted[0])
		Capacity(set,self.a52.known[0],self.a45.accepted[0])
		Capacity(set,self.a15.known[0],self.ma23.accepted[0])
		Capacity(set,self.a50.known[0],self.ma58.accepted[0])
		ICapacity(set,self.a22.known[0],self.a14.accepted[1])
		ICapacity(set,self.a57.known[0],self.a49.accepted[1])
		Capacity(set,self.a48.known[0],self.a60.accepted[0])


		vec = List2Vec(set)
		self.TR[0].rel = self.TR[0].rel & vec.And()

		set = []

		Capacity(set,self.a4.known[0],self.ma16.accepted[0])
		Capacity(set,self.a13.known[0],self.a25.accepted[0])
		Capacity(set,self.a39.known[0],self.ma51.accepted[0])
		Capacity(set,self.a52.known[0],self.a37.accepted[1])
		Capacity(set,self.a17.known[0],self.a2.accepted[1])
		Capacity(set,self.a36.known[0],self.a52.accepted[1])
		ICapacity(set,self.a65.known[0],self.a49.accepted[0])
		ICapacity(set,self.a30.known[0],self.a14.accepted[0])
		Capacity(set,self.a1.known[0],self.a17.accepted[1])
		ICapacity(set,self.a53.known[0],self.a36.accepted[0])
		Capacity(set,self.a2.known[0],self.ma19.accepted[0])
		ICapacity(set,self.a18.known[0],self.a1.accepted[0])
		Capacity(set,self.a37.known[0],self.ma54.accepted[0])
		Capacity(set,self.a10.known[0],self.a31.accepted[0])


		vec = List2Vec(set)
		self.TR[1].rel = self.TR[1].rel & vec.And()

		set = []

		Capacity(set,self.a45.known[0],self.a66.accepted[0])
		ICapacity(set,self.a69.known[0],self.a38.accepted[1])
		ICapacity(set,self.a34.known[0],self.a3.accepted[1])
		ICapacity(set,self.ma56.known[0],self.ma21.accepted[1])
		ICapacity(set,self.io35.known[0],self.io0.accepted[0])
		Capacity(set,self.io0.known[0],self.io35.accepted[0])
		Capacity(set,self.ma21.known[0],self.ma56.accepted[0])


		vec = List2Vec(set)
		self.TR[2].rel = self.TR[2].rel & vec.And()


	def BuildGroups(self):

                alu_list = [self.a1.busy[0], self.a2.busy[0], self.a3.busy[0], self.a4.busy[0], self.a5.busy[0], self.a7.busy[0], self.a8.busy[0], self.a9.busy[0], self.a10.busy[0], self.a11.busy[0], self.a13.busy[0], self.a14.busy[0], self.a15.busy[0], self.a17.busy[0], self.a18.busy[0], self.a20.busy[0], self.a22.busy[0], self.a24.busy[0], self.a25.busy[0], self.a26.busy[0], self.a27.busy[0], self.a29.busy[0], self.a30.busy[0], self.a31.busy[0], self.a33.busy[0], self.a34.busy[0], self.a36.busy[0], self.a37.busy[0], self.a38.busy[0], self.a39.busy[0], self.a40.busy[0], self.a42.busy[0], self.a43.busy[0], self.a44.busy[0], self.a45.busy[0], self.a46.busy[0], self.a48.busy[0], self.a49.busy[0], self.a50.busy[0], self.a52.busy[0], self.a53.busy[0], self.a55.busy[0], self.a57.busy[0], self.a59.busy[0], self.a60.busy[0], self.a61.busy[0], self.a62.busy[0], self.a64.busy[0], self.a65.busy[0], self.a66.busy[0], self.a68.busy[0], self.a69.busy[0]]
		self.alu_res = Group(0, alus, alu_list)
		self.TR.PruneT(self.alu_res.BuildActive(),(0,1))

                mult_list = [self.ma6.busy[0], self.ma12.busy[0], self.ma16.busy[0], self.ma19.busy[0], self.ma21.busy[0], self.ma23.busy[0], self.ma28.busy[0], self.ma32.busy[0], self.ma41.busy[0], self.ma47.busy[0], self.ma51.busy[0], self.ma54.busy[0], self.ma56.busy[0], self.ma58.busy[0], self.ma63.busy[0], self.ma67.busy[0]]
		self.mult_res = Group(0, mults, mult_list)
		self.TR.PruneT(self.mult_res.BuildActive(),(0,1))

                io_list = [self.io0.produced[0], self.ma21.produced[0], self.io35.produced[0], self.ma56.produced[0]]
		self.ioport_res = Group(0, ioports, io_list)
		self.TR.PruneT(self.ioport_res.BuildActive(),(0,1))


bm = Top(0)
bm.BuildCompositeState(0)
bm.BuildRelation()
bm.TR.Info()
bm.TR.SetVarMap()
bm.BuildVectors((0,0),(0,1))
bm.TR.Info()
bm.TR.ReachabilityPrune(bm.taskstart[0],(0,1))
bm.TR.Collapse()
bm.TR.Info()
bm.BuildGroups()
bm.TR.Info()
bm.pin = bm.a46
bm.tagdepth = 10
#bm.Reorder()
result = bm.DFSchedule()
result.Trace()
result.PrintTrace()


print os.times()

