# This file was created automatically by SWIG.
import pycuddc
class IntArrayPtr :
    def __init__(self,this):
        self.this = this
    def __del__(self):
            pycuddc.delete_IntArray(self.this)
    def AssignVect(self,arg0,arg1):
        val = pycuddc.IntArray_AssignVect(self.this,arg0,arg1)
        return val
    def AssignComplVect(self,arg0,arg1,arg2):
        val = pycuddc.IntArray_AssignComplVect(self.this,arg0,arg1,arg2)
        return val
    def __getitem__(self,arg0):
        val = pycuddc.IntArray___getitem__(self.this,arg0)
        return val
    def __setitem__(self,arg0,arg1):
        val = pycuddc.IntArray___setitem__(self.this,arg0,arg1)
        return val
    def __len__(self):
        val = pycuddc.IntArray___len__(self.this)
        return val
    def __setattr__(self,name,value):
        if name == "vec" :
            pycuddc.IntArray_vec_set(self.this,value)
            return
        self.__dict__[name] = value
    def __getattr__(self,name):
        if name == "vec" : 
            return pycuddc.IntArray_vec_get(self.this)
        raise AttributeError,name
    def __repr__(self):
        return "<C IntArray instance>"
class IntArray(IntArrayPtr):
    def __init__(self,arg0) :
        self.this = pycuddc.new_IntArray(arg0)




class DoubleArrayPtr :
    def __init__(self,this):
        self.this = this
    def __del__(self):
            pycuddc.delete_DoubleArray(self.this)
    def __getitem__(self,arg0):
        val = pycuddc.DoubleArray___getitem__(self.this,arg0)
        return val
    def __setitem__(self,arg0,arg1):
        val = pycuddc.DoubleArray___setitem__(self.this,arg0,arg1)
        return val
    def __len__(self):
        val = pycuddc.DoubleArray___len__(self.this)
        return val
    def __setattr__(self,name,value):
        if name == "vec" :
            pycuddc.DoubleArray_vec_set(self.this,value)
            return
        self.__dict__[name] = value
    def __getattr__(self,name):
        if name == "vec" : 
            return pycuddc.DoubleArray_vec_get(self.this)
        raise AttributeError,name
    def __repr__(self):
        return "<C DoubleArray instance>"
class DoubleArray(DoubleArrayPtr):
    def __init__(self,arg0) :
        self.this = pycuddc.new_DoubleArray(arg0)




class DdArrayPtr :
    def __init__(self,this):
        self.this = this
    def __del__(self):
            pycuddc.delete_DdArray(self.this)
    def __getitem__(self,arg0):
        val = pycuddc.DdArray___getitem__(self.this,arg0)
        val = DdNodePtr(val)
        return val
    def __setitem__(self,arg0,arg1):
        val = pycuddc.DdArray___setitem__(self.this,arg0,arg1.this)
        return val
    def __len__(self):
        val = pycuddc.DdArray___len__(self.this)
        return val
    def Pop(self):
        val = pycuddc.DdArray_Pop(self.this)
        val = DdNodePtr(val)
        return val
    def Push(self,arg0):
        val = pycuddc.DdArray_Push(self.this,arg0.this)
        return val
    def And(self):
        val = pycuddc.DdArray_And(self.this)
        val = DdNodePtr(val)
        return val
    def Or(self):
        val = pycuddc.DdArray_Or(self.this)
        val = DdNodePtr(val)
        return val
    def AtLeastN(self,arg0):
        val = pycuddc.DdArray_AtLeastN(self.this,arg0)
        val = DdNodePtr(val)
        return val
    def ExactlyN(self,arg0):
        val = pycuddc.DdArray_ExactlyN(self.this,arg0)
        val = DdNodePtr(val)
        return val
    def UpToN(self,arg0):
        val = pycuddc.DdArray_UpToN(self.this,arg0)
        val = DdNodePtr(val)
        return val
    def Constraint(self,arg0,arg1):
        val = pycuddc.DdArray_Constraint(self.this,arg0,arg1)
        val = DdNodePtr(val)
        return val
    def Compose(self,arg0):
        val = pycuddc.DdArray_Compose(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def Fill(self,arg0,arg1):
        val = pycuddc.DdArray_Fill(self.this,arg0,arg1)
        return val
    def OrderVector(self,arg0,arg1):
        val = pycuddc.DdArray_OrderVector(self.this,arg0,arg1)
        return val
    def SetVarMap(self,arg0):
        val = pycuddc.DdArray_SetVarMap(self.this,arg0.this)
        return val
    def PickOneMinterm(self,arg0):
        val = pycuddc.DdArray_PickOneMinterm(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def HoldTR(self,arg0):
        val = pycuddc.DdArray_HoldTR(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def Save(self,arg0):
        val = pycuddc.DdArray_Save(self.this,arg0)
        return val
    def Load(self,arg0):
        val = pycuddc.DdArray_Load(self.this,arg0)
        return val
    def __setattr__(self,name,value):
        if name == "vec" :
            pycuddc.DdArray_vec_set(self.this,value)
            return
        self.__dict__[name] = value
    def __getattr__(self,name):
        if name == "vec" : 
            return pycuddc.DdArray_vec_get(self.this)
        raise AttributeError,name
    def __repr__(self):
        return "<C DdArray instance>"
class DdArray(DdArrayPtr):
    def __init__(self,arg0) :
        self.this = pycuddc.new_DdArray(arg0)




class MtrNodePtr :
    def __init__(self,this):
        self.this = this
    def __repr__(self):
        return "<C MtrNode instance>"
class MtrNode(MtrNodePtr):
    def __init__(self,this):
        self.this = this




class DdManagerPtr :
    def __init__(self,this):
        self.this = this
    def __del__(self):
            pycuddc.delete_DdManager(self.this)
    def addNewVar(self):
        val = pycuddc.DdManager_addNewVar(self.this)
        val = DdNodePtr(val)
        return val
    def addNewVarAtLevel(self,arg0):
        val = pycuddc.DdManager_addNewVarAtLevel(self.this,arg0)
        val = DdNodePtr(val)
        return val
    def NewVar(self):
        val = pycuddc.DdManager_NewVar(self.this)
        val = DdNodePtr(val)
        return val
    def NewVarAtLevel(self,arg0):
        val = pycuddc.DdManager_NewVarAtLevel(self.this,arg0)
        val = DdNodePtr(val)
        return val
    def addIthVar(self,arg0):
        val = pycuddc.DdManager_addIthVar(self.this,arg0)
        val = DdNodePtr(val)
        return val
    def IthVar(self,arg0):
        val = pycuddc.DdManager_IthVar(self.this,arg0)
        val = DdNodePtr(val)
        return val
    def zddIthVar(self,arg0):
        val = pycuddc.DdManager_zddIthVar(self.this,arg0)
        val = DdNodePtr(val)
        return val
    def zddVarsFromBddVars(self,arg0):
        val = pycuddc.DdManager_zddVarsFromBddVars(self.this,arg0)
        return val
    def addConst(self,arg0):
        val = pycuddc.DdManager_addConst(self.this,arg0)
        val = DdNodePtr(val)
        return val
    def AutodynEnable(self,arg0):
        val = pycuddc.DdManager_AutodynEnable(self.this,arg0)
        return val
    def AutodynDisable(self):
        val = pycuddc.DdManager_AutodynDisable(self.this)
        return val
    def ReorderingStatus(self,arg0):
        val = pycuddc.DdManager_ReorderingStatus(self.this,arg0)
        return val
    def AutodynEnableZdd(self,arg0):
        val = pycuddc.DdManager_AutodynEnableZdd(self.this,arg0)
        return val
    def AutodynDisableZdd(self):
        val = pycuddc.DdManager_AutodynDisableZdd(self.this)
        return val
    def ReorderingStatusZdd(self,arg0):
        val = pycuddc.DdManager_ReorderingStatusZdd(self.this,arg0)
        return val
    def zddRealignmentEnabled(self):
        val = pycuddc.DdManager_zddRealignmentEnabled(self.this)
        return val
    def zddRealignEnable(self):
        val = pycuddc.DdManager_zddRealignEnable(self.this)
        return val
    def zddRealignDisable(self):
        val = pycuddc.DdManager_zddRealignDisable(self.this)
        return val
    def RealignmentEnabled(self):
        val = pycuddc.DdManager_RealignmentEnabled(self.this)
        return val
    def RealignEnable(self):
        val = pycuddc.DdManager_RealignEnable(self.this)
        return val
    def RealignDisable(self):
        val = pycuddc.DdManager_RealignDisable(self.this)
        return val
    def ReadOne(self):
        val = pycuddc.DdManager_ReadOne(self.this)
        val = DdNodePtr(val)
        return val
    def ReadZddOne(self,arg0):
        val = pycuddc.DdManager_ReadZddOne(self.this,arg0)
        val = DdNodePtr(val)
        return val
    def ReadZero(self):
        val = pycuddc.DdManager_ReadZero(self.this)
        val = DdNodePtr(val)
        return val
    def ReadLogicZero(self):
        val = pycuddc.DdManager_ReadLogicZero(self.this)
        val = DdNodePtr(val)
        return val
    def ReadPlusInfinity(self):
        val = pycuddc.DdManager_ReadPlusInfinity(self.this)
        val = DdNodePtr(val)
        return val
    def ReadMinusInfinity(self):
        val = pycuddc.DdManager_ReadMinusInfinity(self.this)
        val = DdNodePtr(val)
        return val
    def ReadBackground(self):
        val = pycuddc.DdManager_ReadBackground(self.this)
        val = DdNodePtr(val)
        return val
    def ReadCacheSlots(self):
        val = pycuddc.DdManager_ReadCacheSlots(self.this)
        return val
    def ReadCacheUsedSlots(self):
        val = pycuddc.DdManager_ReadCacheUsedSlots(self.this)
        return val
    def ReadCacheLookUps(self):
        val = pycuddc.DdManager_ReadCacheLookUps(self.this)
        return val
    def ReadCacheHits(self):
        val = pycuddc.DdManager_ReadCacheHits(self.this)
        return val
    def ReadRecursiveCalls(self):
        val = pycuddc.DdManager_ReadRecursiveCalls(self.this)
        return val
    def ReadMinHit(self):
        val = pycuddc.DdManager_ReadMinHit(self.this)
        return val
    def SetMinHit(self,arg0):
        val = pycuddc.DdManager_SetMinHit(self.this,arg0)
        return val
    def ReadLooseUpTo(self):
        val = pycuddc.DdManager_ReadLooseUpTo(self.this)
        return val
    def SetLooseUpTo(self,arg0):
        val = pycuddc.DdManager_SetLooseUpTo(self.this,arg0)
        return val
    def ReadMaxCache(self):
        val = pycuddc.DdManager_ReadMaxCache(self.this)
        return val
    def ReadMaxCacheHard(self):
        val = pycuddc.DdManager_ReadMaxCacheHard(self.this)
        return val
    def SetMaxCacheHard(self,arg0):
        val = pycuddc.DdManager_SetMaxCacheHard(self.this,arg0)
        return val
    def ReadSize(self):
        val = pycuddc.DdManager_ReadSize(self.this)
        return val
    def ReadZddSize(self):
        val = pycuddc.DdManager_ReadZddSize(self.this)
        return val
    def ReadSlots(self):
        val = pycuddc.DdManager_ReadSlots(self.this)
        return val
    def ReadUsedSlots(self):
        val = pycuddc.DdManager_ReadUsedSlots(self.this)
        return val
    def ExpectedUsedSlots(self):
        val = pycuddc.DdManager_ExpectedUsedSlots(self.this)
        return val
    def ReadKeys(self):
        val = pycuddc.DdManager_ReadKeys(self.this)
        return val
    def ReadDead(self):
        val = pycuddc.DdManager_ReadDead(self.this)
        return val
    def ReadMinDead(self):
        val = pycuddc.DdManager_ReadMinDead(self.this)
        return val
    def ReadReorderings(self):
        val = pycuddc.DdManager_ReadReorderings(self.this)
        return val
    def ReadReorderingTime(self):
        val = pycuddc.DdManager_ReadReorderingTime(self.this)
        return val
    def ReadGarbageCollections(self):
        val = pycuddc.DdManager_ReadGarbageCollections(self.this)
        return val
    def ReadGarbageCollectionTime(self):
        val = pycuddc.DdManager_ReadGarbageCollectionTime(self.this)
        return val
    def GarbageCollect(self,arg0):
        val = pycuddc.DdManager_GarbageCollect(self.this,arg0)
        return val
    def ReadNodesFreed(self):
        val = pycuddc.DdManager_ReadNodesFreed(self.this)
        return val
    def ReadNodesDropped(self):
        val = pycuddc.DdManager_ReadNodesDropped(self.this)
        return val
    def ReadUniqueLookUps(self):
        val = pycuddc.DdManager_ReadUniqueLookUps(self.this)
        return val
    def ReadUniqueLinks(self):
        val = pycuddc.DdManager_ReadUniqueLinks(self.this)
        return val
    def ReadSiftMaxVar(self):
        val = pycuddc.DdManager_ReadSiftMaxVar(self.this)
        return val
    def SetSiftMaxVar(self,arg0):
        val = pycuddc.DdManager_SetSiftMaxVar(self.this,arg0)
        return val
    def ReadSiftMaxSwap(self):
        val = pycuddc.DdManager_ReadSiftMaxSwap(self.this)
        return val
    def SetSiftMaxSwap(self,arg0):
        val = pycuddc.DdManager_SetSiftMaxSwap(self.this,arg0)
        return val
    def ReadMaxGrowth(self):
        val = pycuddc.DdManager_ReadMaxGrowth(self.this)
        return val
    def SetMaxGrowth(self,arg0):
        val = pycuddc.DdManager_SetMaxGrowth(self.this,arg0)
        return val
    def ReadTree(self):
        val = pycuddc.DdManager_ReadTree(self.this)
        val = MtrNodePtr(val)
        return val
    def SetTree(self,arg0):
        val = pycuddc.DdManager_SetTree(self.this,arg0.this)
        return val
    def FreeTree(self):
        val = pycuddc.DdManager_FreeTree(self.this)
        return val
    def ReadZddTree(self):
        val = pycuddc.DdManager_ReadZddTree(self.this)
        val = MtrNodePtr(val)
        return val
    def SetZddTree(self,arg0):
        val = pycuddc.DdManager_SetZddTree(self.this,arg0.this)
        return val
    def FreeZddTree(self):
        val = pycuddc.DdManager_FreeZddTree(self.this)
        return val
    def ReadPerm(self,arg0):
        val = pycuddc.DdManager_ReadPerm(self.this,arg0)
        return val
    def ReadPermZdd(self,arg0):
        val = pycuddc.DdManager_ReadPermZdd(self.this,arg0)
        return val
    def ReadInvPerm(self,arg0):
        val = pycuddc.DdManager_ReadInvPerm(self.this,arg0)
        return val
    def ReadInvPermZdd(self,arg0):
        val = pycuddc.DdManager_ReadInvPermZdd(self.this,arg0)
        return val
    def ReadVars(self,arg0):
        val = pycuddc.DdManager_ReadVars(self.this,arg0)
        val = DdNodePtr(val)
        return val
    def ReadEpsilon(self):
        val = pycuddc.DdManager_ReadEpsilon(self.this)
        return val
    def SetEpsilon(self,arg0):
        val = pycuddc.DdManager_SetEpsilon(self.this,arg0)
        return val
    def ReadGroupcheck(self):
        val = pycuddc.DdManager_ReadGroupcheck(self.this)
        return val
    def SetGroupcheck(self,arg0):
        val = pycuddc.DdManager_SetGroupcheck(self.this,arg0)
        return val
    def GarbageCollectionEnabled(self):
        val = pycuddc.DdManager_GarbageCollectionEnabled(self.this)
        return val
    def EnableGarbageCollection(self):
        val = pycuddc.DdManager_EnableGarbageCollection(self.this)
        return val
    def DisableGarbageCollection(self):
        val = pycuddc.DdManager_DisableGarbageCollection(self.this)
        return val
    def DeadAreCounted(self):
        val = pycuddc.DdManager_DeadAreCounted(self.this)
        return val
    def TurnOnCountDead(self):
        val = pycuddc.DdManager_TurnOnCountDead(self.this)
        return val
    def TurnOffCountDead(self):
        val = pycuddc.DdManager_TurnOffCountDead(self.this)
        return val
    def ReadRecomb(self):
        val = pycuddc.DdManager_ReadRecomb(self.this)
        return val
    def SetRecomb(self,arg0):
        val = pycuddc.DdManager_SetRecomb(self.this,arg0)
        return val
    def ReadSymmviolation(self):
        val = pycuddc.DdManager_ReadSymmviolation(self.this)
        return val
    def SetSymmviolation(self,arg0):
        val = pycuddc.DdManager_SetSymmviolation(self.this,arg0)
        return val
    def ReadArcviolation(self):
        val = pycuddc.DdManager_ReadArcviolation(self.this)
        return val
    def SetArcviolation(self,arg0):
        val = pycuddc.DdManager_SetArcviolation(self.this,arg0)
        return val
    def ReadPopulationSize(self):
        val = pycuddc.DdManager_ReadPopulationSize(self.this)
        return val
    def SetPopulationSize(self,arg0):
        val = pycuddc.DdManager_SetPopulationSize(self.this,arg0)
        return val
    def ReadNumberXovers(self):
        val = pycuddc.DdManager_ReadNumberXovers(self.this)
        return val
    def SetNumberXovers(self,arg0):
        val = pycuddc.DdManager_SetNumberXovers(self.this,arg0)
        return val
    def ReadMemoryInUse(self):
        val = pycuddc.DdManager_ReadMemoryInUse(self.this)
        return val
    def PrintInfo(self,arg0):
        val = pycuddc.DdManager_PrintInfo(self.this,arg0)
        return val
    def ReadPeakNodeCount(self):
        val = pycuddc.DdManager_ReadPeakNodeCount(self.this)
        return val
    def ReadPeakLiveNodeCount(self):
        val = pycuddc.DdManager_ReadPeakLiveNodeCount(self.this)
        return val
    def ReadNodeCount(self):
        val = pycuddc.DdManager_ReadNodeCount(self.this)
        return val
    def zddReadNodeCount(self):
        val = pycuddc.DdManager_zddReadNodeCount(self.this)
        return val
    def EnableReorderingReporting(self):
        val = pycuddc.DdManager_EnableReorderingReporting(self.this)
        return val
    def DisableReorderingReporting(self):
        val = pycuddc.DdManager_DisableReorderingReporting(self.this)
        return val
    def ReorderingReporting(self):
        val = pycuddc.DdManager_ReorderingReporting(self.this)
        return val
    def ReadErrorCode(self):
        val = pycuddc.DdManager_ReadErrorCode(self.this)
        return val
    def ClearErrorCode(self):
        val = pycuddc.DdManager_ClearErrorCode(self.this)
        return val
    def ReadStdout(self):
        val = pycuddc.DdManager_ReadStdout(self.this)
        return val
    def SetStdout(self,arg0):
        val = pycuddc.DdManager_SetStdout(self.this,arg0)
        return val
    def ReadStderr(self):
        val = pycuddc.DdManager_ReadStderr(self.this)
        return val
    def SetStderr(self,arg0):
        val = pycuddc.DdManager_SetStderr(self.this,arg0)
        return val
    def ReadNextReordering(self):
        val = pycuddc.DdManager_ReadNextReordering(self.this)
        return val
    def ReadSwapSteps(self):
        val = pycuddc.DdManager_ReadSwapSteps(self.this)
        return val
    def ReadMaxLive(self):
        val = pycuddc.DdManager_ReadMaxLive(self.this)
        return val
    def SetMaxLive(self,arg0):
        val = pycuddc.DdManager_SetMaxLive(self.this,arg0)
        return val
    def ReadMaxMemory(self):
        val = pycuddc.DdManager_ReadMaxMemory(self.this)
        return val
    def SetMaxMemory(self,arg0):
        val = pycuddc.DdManager_SetMaxMemory(self.this,arg0)
        return val
    def SetNextReordering(self,arg0):
        val = pycuddc.DdManager_SetNextReordering(self.this,arg0)
        return val
    def DebugCheck(self):
        val = pycuddc.DdManager_DebugCheck(self.this)
        return val
    def CheckKeys(self):
        val = pycuddc.DdManager_CheckKeys(self.this)
        return val
    def MakeTreeNode(self,arg0,arg1,arg2):
        val = pycuddc.DdManager_MakeTreeNode(self.this,arg0,arg1,arg2)
        val = MtrNodePtr(val)
        return val
    def PrintLinear(self):
        val = pycuddc.DdManager_PrintLinear(self.this)
        return val
    def ReadLinear(self,arg0,arg1):
        val = pycuddc.DdManager_ReadLinear(self.this,arg0,arg1)
        return val
    def CheckZeroRef(self):
        val = pycuddc.DdManager_CheckZeroRef(self.this)
        return val
    def ReduceHeap(self,arg0,arg1):
        val = pycuddc.DdManager_ReduceHeap(self.this,arg0,arg1)
        return val
    def ShuffleHeap(self,arg0):
        val = pycuddc.DdManager_ShuffleHeap(self.this,arg0.this)
        return val
    def SymmProfile(self,arg0,arg1):
        val = pycuddc.DdManager_SymmProfile(self.this,arg0,arg1)
        return val
    def IndicesToCube(self,arg0,arg1):
        val = pycuddc.DdManager_IndicesToCube(self.this,arg0.this,arg1)
        val = DdNodePtr(val)
        return val
    def AverageDistance(self):
        val = pycuddc.DdManager_AverageDistance(self.this)
        return val
    def MakeZddTreeNode(self,arg0,arg1,arg2):
        val = pycuddc.DdManager_MakeZddTreeNode(self.this,arg0,arg1,arg2)
        val = MtrNodePtr(val)
        return val
    def zddPrintSubtable(self):
        val = pycuddc.DdManager_zddPrintSubtable(self.this)
        return val
    def zddReduceHeap(self,arg0,arg1):
        val = pycuddc.DdManager_zddReduceHeap(self.this,arg0,arg1)
        return val
    def zddShuffleHeap(self,arg0):
        val = pycuddc.DdManager_zddShuffleHeap(self.this,arg0.this)
        return val
    def zddSymmProfile(self,arg0,arg1):
        val = pycuddc.DdManager_zddSymmProfile(self.this,arg0,arg1)
        return val
    def BddToAdd(self,arg0):
        val = pycuddc.DdManager_BddToAdd(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def addBddPattern(self,arg0):
        val = pycuddc.DdManager_addBddPattern(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def addBddThreshold(self,arg0,arg1):
        val = pycuddc.DdManager_addBddThreshold(self.this,arg0.this,arg1)
        val = DdNodePtr(val)
        return val
    def addBddStrictThreshold(self,arg0,arg1):
        val = pycuddc.DdManager_addBddStrictThreshold(self.this,arg0.this,arg1)
        val = DdNodePtr(val)
        return val
    def addBddInterval(self,arg0,arg1,arg2):
        val = pycuddc.DdManager_addBddInterval(self.this,arg0.this,arg1,arg2)
        val = DdNodePtr(val)
        return val
    def addBddIthBit(self,arg0,arg1):
        val = pycuddc.DdManager_addBddIthBit(self.this,arg0.this,arg1)
        val = DdNodePtr(val)
        return val
    def zddPortFromBdd(self,arg0):
        val = pycuddc.DdManager_zddPortFromBdd(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def zddPortToBdd(self,arg0):
        val = pycuddc.DdManager_zddPortToBdd(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def MakeBddFromZddCover(self,arg0):
        val = pycuddc.DdManager_MakeBddFromZddCover(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def PrintVersion(self,arg0):
        val = pycuddc.DdManager_PrintVersion(self.this,arg0)
        return val
    def Random(self):
        val = pycuddc.DdManager_Random(self.this)
        return val
    def Srandom(self,arg0):
        val = pycuddc.DdManager_Srandom(self.this,arg0)
        return val
    def OutOfMem(self,arg0):
        val = pycuddc.DdManager_OutOfMem(self.this,arg0)
        return val
    def Transfer(self,arg0,arg1):
        val = pycuddc.DdManager_Transfer(self.this,arg0.this,arg1.this)
        val = DdNodePtr(val)
        return val
    def SetVarMap(self,arg0,arg1,arg2):
        val = pycuddc.DdManager_SetVarMap(self.this,arg0.this,arg1.this,arg2)
        return val
    def ComputeCube(self,arg0,arg1,arg2):
        val = pycuddc.DdManager_ComputeCube(self.this,arg0.this,arg1.this,arg2)
        val = DdNodePtr(val)
        return val
    def zddDumpDot(self,arg0,arg1,arg2,arg3,arg4):
        val = pycuddc.DdManager_zddDumpDot(self.this,arg0,arg1.this,arg2,arg3,arg4)
        return val
    def DumpBlif(self,arg0,arg1,arg2,arg3,arg4,arg5):
        val = pycuddc.DdManager_DumpBlif(self.this,arg0,arg1.this,arg2,arg3,arg4,arg5)
        return val
    def DumpBlifBody(self,arg0,arg1,arg2,arg3,arg4):
        val = pycuddc.DdManager_DumpBlifBody(self.this,arg0,arg1.this,arg2,arg3,arg4)
        return val
    def DumpDot(self,arg0,arg1,arg2,arg3,arg4):
        val = pycuddc.DdManager_DumpDot(self.this,arg0,arg1.this,arg2,arg3,arg4)
        return val
    def DumpDaVinci(self,arg0,arg1,arg2,arg3,arg4):
        val = pycuddc.DdManager_DumpDaVinci(self.this,arg0,arg1.this,arg2,arg3,arg4)
        return val
    def DumpDDcal(self,arg0,arg1,arg2,arg3,arg4):
        val = pycuddc.DdManager_DumpDDcal(self.this,arg0,arg1.this,arg2,arg3,arg4)
        return val
    def DumpFactoredForm(self,arg0,arg1,arg2,arg3,arg4):
        val = pycuddc.DdManager_DumpFactoredForm(self.this,arg0,arg1.this,arg2,arg3,arg4)
        return val
    def VectorSupport(self,arg0,arg1):
        val = pycuddc.DdManager_VectorSupport(self.this,arg0.this,arg1)
        val = DdNodePtr(val)
        return val
    def VectorSupportSize(self,arg0,arg1):
        val = pycuddc.DdManager_VectorSupportSize(self.this,arg0.this,arg1)
        return val
    def ClassifySupport(self,arg0,arg1,arg2,arg3,arg4):
        val = pycuddc.DdManager_ClassifySupport(self.this,arg0.this,arg1.this,arg2.this,arg3.this,arg4.this)
        return val
    def Xgty(self,arg0,arg1,arg2,arg3):
        val = pycuddc.DdManager_Xgty(self.this,arg0,arg1.this,arg2.this,arg3.this)
        val = DdNodePtr(val)
        return val
    def Xeqy(self,arg0,arg1,arg2):
        val = pycuddc.DdManager_Xeqy(self.this,arg0,arg1.this,arg2.this)
        val = DdNodePtr(val)
        return val
    def Dxygtdxz(self,arg0,arg1,arg2,arg3):
        val = pycuddc.DdManager_Dxygtdxz(self.this,arg0,arg1.this,arg2.this,arg3.this)
        val = DdNodePtr(val)
        return val
    def Dxygtdyz(self,arg0,arg1,arg2,arg3):
        val = pycuddc.DdManager_Dxygtdyz(self.this,arg0,arg1.this,arg2.this,arg3.this)
        val = DdNodePtr(val)
        return val
    def SharingSize(self,arg0,arg1):
        val = pycuddc.DdManager_SharingSize(self.this,arg0.this,arg1)
        return val
    def ReadIndex(self,arg0):
        val = pycuddc.DdManager_ReadIndex(self.this,arg0)
        return val
    def addPlus(self,arg0,arg1):
        val = pycuddc.DdManager_addPlus(self.this,arg0.this,arg1.this)
        val = DdNodePtr(val)
        return val
    def addTimes(self,arg0,arg1):
        val = pycuddc.DdManager_addTimes(self.this,arg0.this,arg1.this)
        val = DdNodePtr(val)
        return val
    def addThreshold(self,arg0,arg1):
        val = pycuddc.DdManager_addThreshold(self.this,arg0.this,arg1.this)
        val = DdNodePtr(val)
        return val
    def addSetNZ(self,arg0,arg1):
        val = pycuddc.DdManager_addSetNZ(self.this,arg0.this,arg1.this)
        val = DdNodePtr(val)
        return val
    def addDivide(self,arg0,arg1):
        val = pycuddc.DdManager_addDivide(self.this,arg0.this,arg1.this)
        val = DdNodePtr(val)
        return val
    def addMinus(self,arg0,arg1):
        val = pycuddc.DdManager_addMinus(self.this,arg0.this,arg1.this)
        val = DdNodePtr(val)
        return val
    def addMinimum(self,arg0,arg1):
        val = pycuddc.DdManager_addMinimum(self.this,arg0.this,arg1.this)
        val = DdNodePtr(val)
        return val
    def addMaximum(self,arg0,arg1):
        val = pycuddc.DdManager_addMaximum(self.this,arg0.this,arg1.this)
        val = DdNodePtr(val)
        return val
    def addOneZeroMaximum(self,arg0,arg1):
        val = pycuddc.DdManager_addOneZeroMaximum(self.this,arg0.this,arg1.this)
        val = DdNodePtr(val)
        return val
    def addDiff(self,arg0,arg1):
        val = pycuddc.DdManager_addDiff(self.this,arg0.this,arg1.this)
        val = DdNodePtr(val)
        return val
    def addAgreement(self,arg0,arg1):
        val = pycuddc.DdManager_addAgreement(self.this,arg0.this,arg1.this)
        val = DdNodePtr(val)
        return val
    def addOr(self,arg0,arg1):
        val = pycuddc.DdManager_addOr(self.this,arg0.this,arg1.this)
        val = DdNodePtr(val)
        return val
    def addNand(self,arg0,arg1):
        val = pycuddc.DdManager_addNand(self.this,arg0.this,arg1.this)
        val = DdNodePtr(val)
        return val
    def addNor(self,arg0,arg1):
        val = pycuddc.DdManager_addNor(self.this,arg0.this,arg1.this)
        val = DdNodePtr(val)
        return val
    def addXor(self,arg0,arg1):
        val = pycuddc.DdManager_addXor(self.this,arg0.this,arg1.this)
        val = DdNodePtr(val)
        return val
    def addXnor(self,arg0,arg1):
        val = pycuddc.DdManager_addXnor(self.this,arg0.this,arg1.this)
        val = DdNodePtr(val)
        return val
    def addWalsh(self,arg0,arg1,arg2):
        val = pycuddc.DdManager_addWalsh(self.this,arg0.this,arg1.this,arg2)
        val = DdNodePtr(val)
        return val
    def addHamming(self,arg0,arg1,arg2):
        val = pycuddc.DdManager_addHamming(self.this,arg0.this,arg1.this,arg2)
        val = DdNodePtr(val)
        return val
    def addComputeCube(self,arg0,arg1,arg2):
        val = pycuddc.DdManager_addComputeCube(self.this,arg0.this,arg1.this,arg2)
        val = DdNodePtr(val)
        return val
    def addResidue(self,arg0,arg1,arg2,arg3):
        val = pycuddc.DdManager_addResidue(self.this,arg0,arg1,arg2,arg3)
        val = DdNodePtr(val)
        return val
    def addXeqy(self,arg0,arg1,arg2):
        val = pycuddc.DdManager_addXeqy(self.this,arg0,arg1.this,arg2.this)
        val = DdNodePtr(val)
        return val
    def FirstCube(self,arg0,arg1):
        val = pycuddc.DdManager_FirstCube(self.this,arg0.this,arg1.this)
        return val
    def NextCube(self,arg0,arg1):
        val = pycuddc.DdManager_NextCube(self.this,arg0,arg1.this)
        return val
    def FirstNode(self,arg0,arg1):
        val = pycuddc.DdManager_FirstNode(self.this,arg0.this,arg1.this)
        return val
    def NextNode(self,arg0,arg1):
        val = pycuddc.DdManager_NextNode(self.this,arg0,arg1.this)
        return val
    def GenFree(self,arg0):
        val = pycuddc.DdManager_GenFree(self.this,arg0)
        return val
    def IsGenEmpty(self,arg0):
        val = pycuddc.DdManager_IsGenEmpty(self.this,arg0)
        return val
    def ApaNumberOfDigits(self,arg0):
        val = pycuddc.DdManager_ApaNumberOfDigits(self.this,arg0)
        return val
    def NewApaNumber(self,arg0):
        val = pycuddc.DdManager_NewApaNumber(self.this,arg0)
        return val
    def ApaCopy(self,arg0,arg1,arg2):
        val = pycuddc.DdManager_ApaCopy(self.this,arg0,arg1,arg2)
        return val
    def ApaAdd(self,arg0,arg1,arg2,arg3):
        val = pycuddc.DdManager_ApaAdd(self.this,arg0,arg1,arg2,arg3)
        return val
    def ApaSubtract(self,arg0,arg1,arg2,arg3):
        val = pycuddc.DdManager_ApaSubtract(self.this,arg0,arg1,arg2,arg3)
        return val
    def ApaShortDivision(self,arg0,arg1,arg2,arg3):
        val = pycuddc.DdManager_ApaShortDivision(self.this,arg0,arg1,arg2,arg3)
        return val
    def ApaIntDivision(self,arg0,arg1,arg2,arg3):
        val = pycuddc.DdManager_ApaIntDivision(self.this,arg0,arg1,arg2,arg3)
        return val
    def ApaShiftRight(self,arg0,arg1,arg2,arg3):
        val = pycuddc.DdManager_ApaShiftRight(self.this,arg0,arg1,arg2,arg3)
        return val
    def ApaSetToLiteral(self,arg0,arg1,arg2):
        val = pycuddc.DdManager_ApaSetToLiteral(self.this,arg0,arg1,arg2)
        return val
    def ApaPowerOfTwo(self,arg0,arg1,arg2):
        val = pycuddc.DdManager_ApaPowerOfTwo(self.this,arg0,arg1,arg2)
        return val
    def ApaCompare(self,arg0,arg1,arg2,arg3):
        val = pycuddc.DdManager_ApaCompare(self.this,arg0,arg1,arg2,arg3)
        return val
    def ApaCompareRatios(self,arg0,arg1,arg2,arg3,arg4,arg5):
        val = pycuddc.DdManager_ApaCompareRatios(self.this,arg0,arg1,arg2,arg3,arg4,arg5)
        return val
    def ApaPrintHex(self,arg0,arg1,arg2):
        val = pycuddc.DdManager_ApaPrintHex(self.this,arg0,arg1,arg2)
        return val
    def ApaPrintDecimal(self,arg0,arg1,arg2):
        val = pycuddc.DdManager_ApaPrintDecimal(self.this,arg0,arg1,arg2)
        return val
    def ApaPrintExponential(self,arg0,arg1,arg2,arg3):
        val = pycuddc.DdManager_ApaPrintExponential(self.this,arg0,arg1,arg2,arg3)
        return val
    def One(self):
        val = pycuddc.DdManager_One(self.this)
        val = DdNodePtr(val)
        return val
    def Zero(self):
        val = pycuddc.DdManager_Zero(self.this)
        val = DdNodePtr(val)
        return val
    def Sort(self,arg0,arg1):
        val = pycuddc.DdManager_Sort(self.this,arg0.this,arg1.this)
        return val
    def PrintStdOut(self):
        val = pycuddc.DdManager_PrintStdOut(self.this)
        return val
    def StateCube(self,arg0,arg1,arg2,arg3):
        val = pycuddc.DdManager_StateCube(self.this,arg0,arg1,arg2,arg3)
        val = DdNodePtr(val)
        return val
    def BlockStateCube(self,arg0,arg1,arg2,arg3,arg4):
        val = pycuddc.DdManager_BlockStateCube(self.this,arg0,arg1,arg2,arg3,arg4)
        val = DdNodePtr(val)
        return val
    def SetDefault(self):
        val = pycuddc.DdManager_SetDefault(self.this)
        return val
    def __repr__(self):
        return "<C DdManager instance>"
class DdManager(DdManagerPtr):
    def __init__(self,*args) :
        self.this = apply(pycuddc.new_DdManager,()+args)




class DdNodePtr :
    def __init__(self,this):
        self.this = this
    def __del__(self):
            pycuddc.delete_DdNode(self.this)
    def ExistAbstract(self,arg0):
        val = pycuddc.DdNode_ExistAbstract(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def XorExistAbstract(self,arg0,arg1):
        val = pycuddc.DdNode_XorExistAbstract(self.this,arg0.this,arg1.this)
        val = DdNodePtr(val)
        return val
    def UnivAbstract(self,arg0):
        val = pycuddc.DdNode_UnivAbstract(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def BooleanDiff(self,arg0):
        val = pycuddc.DdNode_BooleanDiff(self.this,arg0)
        val = DdNodePtr(val)
        return val
    def AndAbstract(self,arg0,arg1):
        val = pycuddc.DdNode_AndAbstract(self.this,arg0.this,arg1.this)
        val = DdNodePtr(val)
        return val
    def VarIsDependent(self,arg0):
        val = pycuddc.DdNode_VarIsDependent(self.this,arg0.this)
        return val
    def Correlation(self,arg0):
        val = pycuddc.DdNode_Correlation(self.this,arg0.this)
        return val
    def CorrelationWeights(self,arg0,arg1):
        val = pycuddc.DdNode_CorrelationWeights(self.this,arg0.this,arg1.this)
        return val
    def Ite(self,arg0,arg1):
        val = pycuddc.DdNode_Ite(self.this,arg0.this,arg1.this)
        val = DdNodePtr(val)
        return val
    def IteConstant(self,arg0,arg1):
        val = pycuddc.DdNode_IteConstant(self.this,arg0.this,arg1.this)
        val = DdNodePtr(val)
        return val
    def Intersect(self,arg0):
        val = pycuddc.DdNode_Intersect(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def FIntersect(self,arg0):
        val = pycuddc.DdNode_FIntersect(self.this,arg0.this)
        return val
    def And(self,arg0):
        val = pycuddc.DdNode_And(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def Or(self,arg0):
        val = pycuddc.DdNode_Or(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def Nand(self,arg0):
        val = pycuddc.DdNode_Nand(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def Nor(self,arg0):
        val = pycuddc.DdNode_Nor(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def Xor(self,arg0):
        val = pycuddc.DdNode_Xor(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def Xnor(self,arg0):
        val = pycuddc.DdNode_Xnor(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def ClippingAnd(self,arg0,arg1,arg2):
        val = pycuddc.DdNode_ClippingAnd(self.this,arg0.this,arg1,arg2)
        val = DdNodePtr(val)
        return val
    def ClippingAndAbstract(self,arg0,arg1,arg2,arg3):
        val = pycuddc.DdNode_ClippingAndAbstract(self.this,arg0.this,arg1.this,arg2,arg3)
        val = DdNodePtr(val)
        return val
    def LICompaction(self,arg0):
        val = pycuddc.DdNode_LICompaction(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def Squeeze(self,arg0):
        val = pycuddc.DdNode_Squeeze(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def Minimize(self,arg0):
        val = pycuddc.DdNode_Minimize(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def Constrain(self,arg0):
        val = pycuddc.DdNode_Constrain(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def Restrict(self,arg0):
        val = pycuddc.DdNode_Restrict(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def PickOneCube(self,arg0):
        val = pycuddc.DdNode_PickOneCube(self.this,arg0)
        return val
    def PickOneMinterm(self,arg0,arg1):
        val = pycuddc.DdNode_PickOneMinterm(self.this,arg0.this,arg1)
        val = DdNodePtr(val)
        return val
    def PickArbitraryMinterms(self,arg0,arg1,arg2):
        val = pycuddc.DdNode_PickArbitraryMinterms(self.this,arg0.this,arg1,arg2)
        val = DdArrayPtr(val)
        return val
    def Compose(self,arg0,arg1):
        val = pycuddc.DdNode_Compose(self.this,arg0.this,arg1)
        val = DdNodePtr(val)
        return val
    def Permute(self,arg0):
        val = pycuddc.DdNode_Permute(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def VarMap(self):
        val = pycuddc.DdNode_VarMap(self.this)
        val = DdNodePtr(val)
        return val
    def LiteralSetIntersection(self,arg0):
        val = pycuddc.DdNode_LiteralSetIntersection(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def IsVarEssential(self,arg0,arg1):
        val = pycuddc.DdNode_IsVarEssential(self.this,arg0,arg1)
        return val
    def Leq(self,arg0):
        val = pycuddc.DdNode_Leq(self.this,arg0.this)
        return val
    def CharToVect(self):
        val = pycuddc.DdNode_CharToVect(self.this)
        val = DdArrayPtr(val)
        return val
    def ConstrainDecomp(self):
        val = pycuddc.DdNode_ConstrainDecomp(self.this)
        val = DdArrayPtr(val)
        return val
    def Isop(self,arg0):
        val = pycuddc.DdNode_Isop(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def SwapVariables(self,arg0,arg1,arg2):
        val = pycuddc.DdNode_SwapVariables(self.this,arg0.this,arg1.this,arg2)
        val = DdNodePtr(val)
        return val
    def AdjPermuteX(self,arg0,arg1):
        val = pycuddc.DdNode_AdjPermuteX(self.this,arg0.this,arg1)
        val = DdNodePtr(val)
        return val
    def VectorCompose(self,arg0):
        val = pycuddc.DdNode_VectorCompose(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def SetBackground(self):
        val = pycuddc.DdNode_SetBackground(self.this)
        return val
    def UnderApprox(self,arg0,arg1,arg2,arg3):
        val = pycuddc.DdNode_UnderApprox(self.this,arg0,arg1,arg2,arg3)
        val = DdNodePtr(val)
        return val
    def OverApprox(self,arg0,arg1,arg2,arg3):
        val = pycuddc.DdNode_OverApprox(self.this,arg0,arg1,arg2,arg3)
        val = DdNodePtr(val)
        return val
    def RemapUnderApprox(self,arg0,arg1,arg2):
        val = pycuddc.DdNode_RemapUnderApprox(self.this,arg0,arg1,arg2)
        val = DdNodePtr(val)
        return val
    def RemapOverApprox(self,arg0,arg1,arg2):
        val = pycuddc.DdNode_RemapOverApprox(self.this,arg0,arg1,arg2)
        val = DdNodePtr(val)
        return val
    def BiasedUnderApprox(self,arg0,arg1,arg2,arg3,arg4):
        val = pycuddc.DdNode_BiasedUnderApprox(self.this,arg0.this,arg1,arg2,arg3,arg4)
        val = DdNodePtr(val)
        return val
    def BiasedOverApprox(self,arg0,arg1,arg2,arg3,arg4):
        val = pycuddc.DdNode_BiasedOverApprox(self.this,arg0.this,arg1,arg2,arg3,arg4)
        val = DdNodePtr(val)
        return val
    def Cofactor(self,arg0):
        val = pycuddc.DdNode_Cofactor(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def FindEssential(self):
        val = pycuddc.DdNode_FindEssential(self.this)
        val = DdNodePtr(val)
        return val
    def SubsetCompress(self,arg0,arg1):
        val = pycuddc.DdNode_SubsetCompress(self.this,arg0,arg1)
        val = DdNodePtr(val)
        return val
    def SupersetCompress(self,arg0,arg1):
        val = pycuddc.DdNode_SupersetCompress(self.this,arg0,arg1)
        val = DdNodePtr(val)
        return val
    def CProjection(self,arg0):
        val = pycuddc.DdNode_CProjection(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def MinHammingDist(self,arg0,arg1):
        val = pycuddc.DdNode_MinHammingDist(self.this,arg0.this,arg1)
        return val
    def Eval(self,arg0):
        val = pycuddc.DdNode_Eval(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def ShortestPath(self,arg0,arg1,arg2):
        val = pycuddc.DdNode_ShortestPath(self.this,arg0.this,arg1.this,arg2.this)
        val = DdNodePtr(val)
        return val
    def LargestCube(self,arg0):
        val = pycuddc.DdNode_LargestCube(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def ShortestLength(self,arg0):
        val = pycuddc.DdNode_ShortestLength(self.this,arg0.this)
        return val
    def Decreasing(self,arg0):
        val = pycuddc.DdNode_Decreasing(self.this,arg0)
        val = DdNodePtr(val)
        return val
    def Increasing(self,arg0):
        val = pycuddc.DdNode_Increasing(self.this,arg0)
        val = DdNodePtr(val)
        return val
    def EquivDC(self,arg0,arg1):
        val = pycuddc.DdNode_EquivDC(self.this,arg0.this,arg1.this)
        return val
    def EqualSupNorm(self,arg0,arg1,arg2):
        val = pycuddc.DdNode_EqualSupNorm(self.this,arg0.this,arg1,arg2)
        return val
    def CofMinterm(self):
        val = pycuddc.DdNode_CofMinterm(self.this)
        val = DoubleArrayPtr(val)
        return val
    def VerifySol(self,arg0,arg1,arg2):
        val = pycuddc.DdNode_VerifySol(self.this,arg0.this,arg1.this,arg2)
        val = DdNodePtr(val)
        return val
    def SplitSet(self,arg0,arg1,arg2):
        val = pycuddc.DdNode_SplitSet(self.this,arg0.this,arg1,arg2)
        val = DdNodePtr(val)
        return val
    def SubsetHeavyBranch(self,arg0,arg1):
        val = pycuddc.DdNode_SubsetHeavyBranch(self.this,arg0,arg1)
        val = DdNodePtr(val)
        return val
    def SupersetHeavyBranch(self,arg0,arg1):
        val = pycuddc.DdNode_SupersetHeavyBranch(self.this,arg0,arg1)
        val = DdNodePtr(val)
        return val
    def SubsetShortPaths(self,arg0,arg1,arg2):
        val = pycuddc.DdNode_SubsetShortPaths(self.this,arg0,arg1,arg2)
        val = DdNodePtr(val)
        return val
    def SupersetShortPaths(self,arg0,arg1,arg2):
        val = pycuddc.DdNode_SupersetShortPaths(self.this,arg0,arg1,arg2)
        val = DdNodePtr(val)
        return val
    def PrintMinterm(self):
        val = pycuddc.DdNode_PrintMinterm(self.this)
        return val
    def PrintDebug(self,arg0,arg1):
        val = pycuddc.DdNode_PrintDebug(self.this,arg0,arg1)
        return val
    def EstimateCofactor(self,arg0,arg1):
        val = pycuddc.DdNode_EstimateCofactor(self.this,arg0,arg1)
        return val
    def CountMinterm(self,arg0):
        val = pycuddc.DdNode_CountMinterm(self.this,arg0)
        return val
    def Support(self):
        val = pycuddc.DdNode_Support(self.this)
        val = DdNodePtr(val)
        return val
    def SupportSize(self):
        val = pycuddc.DdNode_SupportSize(self.this)
        return val
    def Density(self,arg0):
        val = pycuddc.DdNode_Density(self.this,arg0)
        return val
    def NodeReadIndex(self):
        val = pycuddc.DdNode_NodeReadIndex(self.this)
        return val
    def IsNonConstant(self):
        val = pycuddc.DdNode_IsNonConstant(self.this)
        return val
    def DagSize(self):
        val = pycuddc.DdNode_DagSize(self.this)
        return val
    def EstimateCofactorSimple(self,arg0):
        val = pycuddc.DdNode_EstimateCofactorSimple(self.this,arg0)
        return val
    def CountPath(self):
        val = pycuddc.DdNode_CountPath(self.this)
        return val
    def CountLeaves(self):
        val = pycuddc.DdNode_CountLeaves(self.this)
        return val
    def IsConstant(self):
        val = pycuddc.DdNode_IsConstant(self.this)
        return val
    def Not(self):
        val = pycuddc.DdNode_Not(self.this)
        val = DdNodePtr(val)
        return val
    def NotCond(self,arg0):
        val = pycuddc.DdNode_NotCond(self.this,arg0)
        val = DdNodePtr(val)
        return val
    def Regular(self):
        val = pycuddc.DdNode_Regular(self.this)
        val = DdNodePtr(val)
        return val
    def Complement(self):
        val = pycuddc.DdNode_Complement(self.this)
        val = DdNodePtr(val)
        return val
    def IsComplement(self):
        val = pycuddc.DdNode_IsComplement(self.this)
        return val
    def T(self):
        val = pycuddc.DdNode_T(self.this)
        val = DdNodePtr(val)
        return val
    def E(self):
        val = pycuddc.DdNode_E(self.this)
        val = DdNodePtr(val)
        return val
    def V(self):
        val = pycuddc.DdNode_V(self.this)
        return val
    def ReadIndex(self,arg0):
        val = pycuddc.DdNode_ReadIndex(self.this,arg0)
        return val
    def addExistAbstract(self,arg0):
        val = pycuddc.DdNode_addExistAbstract(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def addUnivAbstract(self,arg0):
        val = pycuddc.DdNode_addUnivAbstract(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def addOrAbstract(self,arg0):
        val = pycuddc.DdNode_addOrAbstract(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def addFindMax(self):
        val = pycuddc.DdNode_addFindMax(self.this)
        val = DdNodePtr(val)
        return val
    def addFindMin(self):
        val = pycuddc.DdNode_addFindMin(self.this)
        val = DdNodePtr(val)
        return val
    def addIthBit(self,arg0):
        val = pycuddc.DdNode_addIthBit(self.this,arg0)
        val = DdNodePtr(val)
        return val
    def addScalarInverse(self,arg0):
        val = pycuddc.DdNode_addScalarInverse(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def addIte(self,arg0,arg1):
        val = pycuddc.DdNode_addIte(self.this,arg0.this,arg1.this)
        val = DdNodePtr(val)
        return val
    def addIteConstant(self,arg0,arg1):
        val = pycuddc.DdNode_addIteConstant(self.this,arg0.this,arg1.this)
        val = DdNodePtr(val)
        return val
    def addEvalConst(self,arg0):
        val = pycuddc.DdNode_addEvalConst(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def addLeq(self,arg0):
        val = pycuddc.DdNode_addLeq(self.this,arg0.this)
        return val
    def addCmpl(self):
        val = pycuddc.DdNode_addCmpl(self.this)
        val = DdNodePtr(val)
        return val
    def addNegate(self):
        val = pycuddc.DdNode_addNegate(self.this)
        val = DdNodePtr(val)
        return val
    def addRoundOff(self,arg0):
        val = pycuddc.DdNode_addRoundOff(self.this,arg0)
        val = DdNodePtr(val)
        return val
    def addCompose(self,arg0,arg1):
        val = pycuddc.DdNode_addCompose(self.this,arg0.this,arg1)
        val = DdNodePtr(val)
        return val
    def addPermute(self,arg0):
        val = pycuddc.DdNode_addPermute(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def addConstrain(self,arg0):
        val = pycuddc.DdNode_addConstrain(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def addRestrict(self,arg0):
        val = pycuddc.DdNode_addRestrict(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def addMatrixMultiply(self,arg0,arg1,arg2):
        val = pycuddc.DdNode_addMatrixMultiply(self.this,arg0.this,arg1.this,arg2)
        val = DdNodePtr(val)
        return val
    def addTimesPlus(self,arg0,arg1,arg2):
        val = pycuddc.DdNode_addTimesPlus(self.this,arg0.this,arg1.this,arg2)
        val = DdNodePtr(val)
        return val
    def addTriangle(self,arg0,arg1,arg2):
        val = pycuddc.DdNode_addTriangle(self.this,arg0.this,arg1.this,arg2)
        val = DdNodePtr(val)
        return val
    def addVectorCompose(self,arg0):
        val = pycuddc.DdNode_addVectorCompose(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def addNonSimCompose(self,arg0):
        val = pycuddc.DdNode_addNonSimCompose(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def addSwapVariables(self,arg0,arg1,arg2):
        val = pycuddc.DdNode_addSwapVariables(self.this,arg0.this,arg1.this,arg2)
        val = DdNodePtr(val)
        return val
    def zddProduct(self,arg0):
        val = pycuddc.DdNode_zddProduct(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def zddUnateProduct(self,arg0):
        val = pycuddc.DdNode_zddUnateProduct(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def zddWeakDiv(self,arg0):
        val = pycuddc.DdNode_zddWeakDiv(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def zddDivide(self,arg0):
        val = pycuddc.DdNode_zddDivide(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def zddWeakDivF(self,arg0):
        val = pycuddc.DdNode_zddWeakDivF(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def zddDivideF(self,arg0):
        val = pycuddc.DdNode_zddDivideF(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def zddComplement(self):
        val = pycuddc.DdNode_zddComplement(self.this)
        val = DdNodePtr(val)
        return val
    def zddIte(self,arg0,arg1):
        val = pycuddc.DdNode_zddIte(self.this,arg0.this,arg1.this)
        val = DdNodePtr(val)
        return val
    def zddUnion(self,arg0):
        val = pycuddc.DdNode_zddUnion(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def zddIntersect(self,arg0):
        val = pycuddc.DdNode_zddIntersect(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def zddDiff(self,arg0):
        val = pycuddc.DdNode_zddDiff(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def zddDiffConst(self,arg0):
        val = pycuddc.DdNode_zddDiffConst(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def zddSubset1(self,arg0):
        val = pycuddc.DdNode_zddSubset1(self.this,arg0)
        val = DdNodePtr(val)
        return val
    def zddSubset0(self,arg0):
        val = pycuddc.DdNode_zddSubset0(self.this,arg0)
        val = DdNodePtr(val)
        return val
    def zddChange(self,arg0):
        val = pycuddc.DdNode_zddChange(self.this,arg0)
        val = DdNodePtr(val)
        return val
    def zddCount(self):
        val = pycuddc.DdNode_zddCount(self.this)
        return val
    def zddCountDouble(self):
        val = pycuddc.DdNode_zddCountDouble(self.this)
        return val
    def zddPrintMinterm(self):
        val = pycuddc.DdNode_zddPrintMinterm(self.this)
        return val
    def zddPrintCover(self):
        val = pycuddc.DdNode_zddPrintCover(self.this)
        return val
    def zddPrintDebug(self,arg0,arg1):
        val = pycuddc.DdNode_zddPrintDebug(self.this,arg0,arg1)
        return val
    def zddCountMinterm(self,arg0):
        val = pycuddc.DdNode_zddCountMinterm(self.this,arg0)
        return val
    def zddIsop(self,arg0,arg1):
        val = pycuddc.DdNode_zddIsop(self.this,arg0.this,arg1.this)
        val = DdNodePtr(val)
        return val
    def zddDagSize(self,arg0):
        val = pycuddc.DdNode_zddDagSize(self.this,arg0.this)
        return val
    def ApaPrintMinterm(self,arg0,arg1):
        val = pycuddc.DdNode_ApaPrintMinterm(self.this,arg0,arg1)
        return val
    def ApaPrintMintermExp(self,arg0,arg1,arg2):
        val = pycuddc.DdNode_ApaPrintMintermExp(self.this,arg0,arg1,arg2)
        return val
    def ApaPrintDensity(self,arg0,arg1):
        val = pycuddc.DdNode_ApaPrintDensity(self.this,arg0,arg1)
        return val
    def ApaCountMinterm(self,arg0,arg1):
        val = pycuddc.DdNode_ApaCountMinterm(self.this,arg0,arg1.this)
        return val
    def __hash__(self):
        val = pycuddc.DdNode___hash__(self.this)
        return val
    def __and__(self,arg0):
        val = pycuddc.DdNode___and__(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def __or__(self,arg0):
        val = pycuddc.DdNode___or__(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def __xor__(self,arg0):
        val = pycuddc.DdNode___xor__(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def __invert__(self):
        val = pycuddc.DdNode___invert__(self.this)
        val = DdNodePtr(val)
        return val
    def __rshift__(self,arg0):
        val = pycuddc.DdNode___rshift__(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def __cmp__(self,arg0):
        val = pycuddc.DdNode___cmp__(self.this,arg0.this)
        return val
    def __sub__(self,arg0):
        val = pycuddc.DdNode___sub__(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def __add__(self,arg0):
        val = pycuddc.DdNode___add__(self.this,arg0.this)
        val = DdNodePtr(val)
        return val
    def SizeOf(self):
        val = pycuddc.DdNode_SizeOf(self.this)
        return val
    def Show(self,arg0,arg1,arg2):
        val = pycuddc.DdNode_Show(self.this,arg0,arg1,arg2)
        return val
    def Empty(self):
        val = pycuddc.DdNode_Empty(self.this)
        return val
    def DumpDot(self):
        val = pycuddc.DdNode_DumpDot(self.this)
        return val
    def Vector(self):
        val = pycuddc.DdNode_Vector(self.this)
        val = DdArrayPtr(val)
        return val
    def __repr__(self):
        return "<C DdNode instance>"
class DdNode(DdNodePtr):
    def __init__(self) :
        self.this = pycuddc.new_DdNode()






#-------------- FUNCTION WRAPPERS ------------------



#-------------- VARIABLE WRAPPERS ------------------

